/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(typeof dojo=="undefined"){
var dj_global=this;
var dj_currentContext=this;
function dj_undef(_1,_2){
return (typeof (_2||dj_currentContext)[_1]=="undefined");
}
if(dj_undef("djConfig",this)){
var djConfig={};
}
if(dj_undef("dojo",this)){
var dojo={};
}
dojo.global=function(){
return dj_currentContext;
};
dojo.locale=djConfig.locale;
dojo.version={major:0,minor:4,patch:1,flag:"p1",revision:Number("$Rev: 8615 $".match(/[0-9]+/)[0]),toString:function(){
with(dojo.version){
return major+"."+minor+"."+patch+flag+" ("+revision+")";
}
}};
dojo.evalProp=function(_3,_4,_5){
if((!_4)||(!_3)){
return undefined;
}
if(!dj_undef(_3,_4)){
return _4[_3];
}
return (_5?(_4[_3]={}):undefined);
};
dojo.parseObjPath=function(_6,_7,_8){
var _9=(_7||dojo.global());
var _a=_6.split(".");
var _b=_a.pop();
for(var i=0,l=_a.length;i<l&&_9;i++){
_9=dojo.evalProp(_a[i],_9,_8);
}
return {obj:_9,prop:_b};
};
dojo.evalObjPath=function(_e,_f){
if(typeof _e!="string"){
return dojo.global();
}
if(_e.indexOf(".")==-1){
return dojo.evalProp(_e,dojo.global(),_f);
}
var ref=dojo.parseObjPath(_e,dojo.global(),_f);
if(ref){
return dojo.evalProp(ref.prop,ref.obj,_f);
}
return null;
};
dojo.errorToString=function(_11){
if(!dj_undef("message",_11)){
return _11.message;
}else{
if(!dj_undef("description",_11)){
return _11.description;
}else{
return _11;
}
}
};
dojo.raise=function(_12,_13){
if(_13){
_12=_12+": "+dojo.errorToString(_13);
}else{
_12=dojo.errorToString(_12);
}
try{
if(djConfig.isDebug){
dojo.hostenv.println("FATAL exception raised: "+_12);
}
}
catch(e){
}
throw _13||Error(_12);
};
dojo.debug=function(){
};
dojo.debugShallow=function(obj){
};
dojo.profile={start:function(){
},end:function(){
},stop:function(){
},dump:function(){
}};
function dj_eval(_15){
return dj_global.eval?dj_global.eval(_15):eval(_15);
}
dojo.unimplemented=function(_16,_17){
var _18="'"+_16+"' not implemented";
if(_17!=null){
_18+=" "+_17;
}
dojo.raise(_18);
};
dojo.deprecated=function(_19,_1a,_1b){
var _1c="DEPRECATED: "+_19;
if(_1a){
_1c+=" "+_1a;
}
if(_1b){
_1c+=" -- will be removed in version: "+_1b;
}
dojo.debug(_1c);
};
dojo.render=(function(){
function vscaffold(_1d,_1e){
var tmp={capable:false,support:{builtin:false,plugin:false},prefixes:_1d};
for(var i=0;i<_1e.length;i++){
tmp[_1e[i]]=false;
}
return tmp;
}
return {name:"",ver:dojo.version,os:{win:false,linux:false,osx:false},html:vscaffold(["html"],["ie","opera","khtml","safari","moz"]),svg:vscaffold(["svg"],["corel","adobe","batik"]),vml:vscaffold(["vml"],["ie"]),swf:vscaffold(["Swf","Flash","Mm"],["mm"]),swt:vscaffold(["Swt"],["ibm"])};
})();
dojo.hostenv=(function(){
var _21={isDebug:false,allowQueryConfig:false,baseScriptUri:"",baseRelativePath:"",libraryScriptUri:"",iePreventClobber:false,ieClobberMinimal:true,preventBackButtonFix:true,delayMozLoadingFix:false,searchIds:[],parseWidgets:true};
if(typeof djConfig=="undefined"){
djConfig=_21;
}else{
for(var _22 in _21){
if(typeof djConfig[_22]=="undefined"){
djConfig[_22]=_21[_22];
}
}
}
return {name_:"(unset)",version_:"(unset)",getName:function(){
return this.name_;
},getVersion:function(){
return this.version_;
},getText:function(uri){
dojo.unimplemented("getText","uri="+uri);
}};
})();
dojo.hostenv.getBaseScriptUri=function(){
if(djConfig.baseScriptUri.length){
return djConfig.baseScriptUri;
}
var uri=new String(djConfig.libraryScriptUri||djConfig.baseRelativePath);
if(!uri){
dojo.raise("Nothing returned by getLibraryScriptUri(): "+uri);
}
var _25=uri.lastIndexOf("/");
djConfig.baseScriptUri=djConfig.baseRelativePath;
return djConfig.baseScriptUri;
};
(function(){
var _26={pkgFileName:"__package__",loading_modules_:{},loaded_modules_:{},addedToLoadingCount:[],removedFromLoadingCount:[],inFlightCount:0,modulePrefixes_:{dojo:{name:"dojo",value:"src"}},setModulePrefix:function(_27,_28){
this.modulePrefixes_[_27]={name:_27,value:_28};
},moduleHasPrefix:function(_29){
var mp=this.modulePrefixes_;
return Boolean(mp[_29]&&mp[_29].value);
},getModulePrefix:function(_2b){
if(this.moduleHasPrefix(_2b)){
return this.modulePrefixes_[_2b].value;
}
return _2b;
},getTextStack:[],loadUriStack:[],loadedUris:[],post_load_:false,modulesLoadedListeners:[],unloadListeners:[],loadNotifying:false};
for(var _2c in _26){
dojo.hostenv[_2c]=_26[_2c];
}
})();
dojo.hostenv.loadPath=function(_2d,_2e,cb){
var uri;
if(_2d.charAt(0)=="/"||_2d.match(/^\w+:/)){
uri=_2d;
}else{
uri=this.getBaseScriptUri()+_2d;
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return !_2e?this.loadUri(uri,cb):this.loadUriAndCheck(uri,_2e,cb);
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb){
if(this.loadedUris[uri]){
return true;
}
var _33=this.getText(uri,null,true);
if(!_33){
return false;
}
this.loadedUris[uri]=true;
if(cb){
_33="("+_33+")";
}
var _34=dj_eval(_33);
if(cb){
cb(_34);
}
return true;
};
dojo.hostenv.loadUriAndCheck=function(uri,_36,cb){
var ok=true;
try{
ok=this.loadUri(uri,cb);
}
catch(e){
dojo.debug("failed loading ",uri," with error: ",e);
}
return Boolean(ok&&this.findModule(_36,false));
};
dojo.loaded=function(){
};
dojo.unloaded=function(){
};
dojo.hostenv.loaded=function(){
this.loadNotifying=true;
this.post_load_=true;
var mll=this.modulesLoadedListeners;
for(var x=0;x<mll.length;x++){
mll[x]();
}
this.modulesLoadedListeners=[];
this.loadNotifying=false;
dojo.loaded();
};
dojo.hostenv.unloaded=function(){
var mll=this.unloadListeners;
while(mll.length){
(mll.pop())();
}
dojo.unloaded();
};
dojo.addOnLoad=function(obj,_3d){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.modulesLoadedListeners.push(obj);
}else{
if(arguments.length>1){
dh.modulesLoadedListeners.push(function(){
obj[_3d]();
});
}
}
if(dh.post_load_&&dh.inFlightCount==0&&!dh.loadNotifying){
dh.callLoaded();
}
};
dojo.addOnUnload=function(obj,_40){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.unloadListeners.push(obj);
}else{
if(arguments.length>1){
dh.unloadListeners.push(function(){
obj[_40]();
});
}
}
};
dojo.hostenv.modulesLoaded=function(){
if(this.post_load_){
return;
}
if(this.loadUriStack.length==0&&this.getTextStack.length==0){
if(this.inFlightCount>0){
dojo.debug("files still in flight!");
return;
}
dojo.hostenv.callLoaded();
}
};
dojo.hostenv.callLoaded=function(){
if(typeof setTimeout=="object"){
setTimeout("dojo.hostenv.loaded();",0);
}else{
dojo.hostenv.loaded();
}
};
dojo.hostenv.getModuleSymbols=function(_42){
var _43=_42.split(".");
for(var i=_43.length;i>0;i--){
var _45=_43.slice(0,i).join(".");
if((i==1)&&!this.moduleHasPrefix(_45)){
_43[0]="../"+_43[0];
}else{
var _46=this.getModulePrefix(_45);
if(_46!=_45){
_43.splice(0,i,_46);
break;
}
}
}
return _43;
};
dojo.hostenv._global_omit_module_check=false;
dojo.hostenv.loadModule=function(_47,_48,_49){
if(!_47){
return;
}
_49=this._global_omit_module_check||_49;
var _4a=this.findModule(_47,false);
if(_4a){
return _4a;
}
if(dj_undef(_47,this.loading_modules_)){
this.addedToLoadingCount.push(_47);
}
this.loading_modules_[_47]=1;
var _4b=_47.replace(/\./g,"/")+".js";
var _4c=_47.split(".");
var _4d=this.getModuleSymbols(_47);
var _4e=((_4d[0].charAt(0)!="/")&&!_4d[0].match(/^\w+:/));
var _4f=_4d[_4d.length-1];
var ok;
if(_4f=="*"){
_47=_4c.slice(0,-1).join(".");
while(_4d.length){
_4d.pop();
_4d.push(this.pkgFileName);
_4b=_4d.join("/")+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,!_49?_47:null);
if(ok){
break;
}
_4d.pop();
}
}else{
_4b=_4d.join("/")+".js";
_47=_4c.join(".");
var _51=!_49?_47:null;
ok=this.loadPath(_4b,_51);
if(!ok&&!_48){
_4d.pop();
while(_4d.length){
_4b=_4d.join("/")+".js";
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
_4d.pop();
_4b=_4d.join("/")+"/"+this.pkgFileName+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
}
}
if(!ok&&!_49){
dojo.raise("Could not load '"+_47+"'; last tried '"+_4b+"'");
}
}
if(!_49&&!this["isXDomain"]){
_4a=this.findModule(_47,false);
if(!_4a){
dojo.raise("symbol '"+_47+"' is not defined after loading '"+_4b+"'");
}
}
return _4a;
};
dojo.hostenv.startPackage=function(_52){
var _53=String(_52);
var _54=_53;
var _55=_52.split(/\./);
if(_55[_55.length-1]=="*"){
_55.pop();
_54=_55.join(".");
}
var _56=dojo.evalObjPath(_54,true);
this.loaded_modules_[_53]=_56;
this.loaded_modules_[_54]=_56;
return _56;
};
dojo.hostenv.findModule=function(_57,_58){
var lmn=String(_57);
if(this.loaded_modules_[lmn]){
return this.loaded_modules_[lmn];
}
if(_58){
dojo.raise("no loaded module named '"+_57+"'");
}
return null;
};
dojo.kwCompoundRequire=function(_5a){
var _5b=_5a["common"]||[];
var _5c=_5a[dojo.hostenv.name_]?_5b.concat(_5a[dojo.hostenv.name_]||[]):_5b.concat(_5a["default"]||[]);
for(var x=0;x<_5c.length;x++){
var _5e=_5c[x];
if(_5e.constructor==Array){
dojo.hostenv.loadModule.apply(dojo.hostenv,_5e);
}else{
dojo.hostenv.loadModule(_5e);
}
}
};
dojo.require=function(_5f){
dojo.hostenv.loadModule.apply(dojo.hostenv,arguments);
};
dojo.requireIf=function(_60,_61){
var _62=arguments[0];
if((_62===true)||(_62=="common")||(_62&&dojo.render[_62].capable)){
var _63=[];
for(var i=1;i<arguments.length;i++){
_63.push(arguments[i]);
}
dojo.require.apply(dojo,_63);
}
};
dojo.requireAfterIf=dojo.requireIf;
dojo.provide=function(_65){
return dojo.hostenv.startPackage.apply(dojo.hostenv,arguments);
};
dojo.registerModulePath=function(_66,_67){
return dojo.hostenv.setModulePrefix(_66,_67);
};
dojo.setModulePrefix=function(_68,_69){
dojo.deprecated("dojo.setModulePrefix(\""+_68+"\", \""+_69+"\")","replaced by dojo.registerModulePath","0.5");
return dojo.registerModulePath(_68,_69);
};
dojo.exists=function(obj,_6b){
var p=_6b.split(".");
for(var i=0;i<p.length;i++){
if(!obj[p[i]]){
return false;
}
obj=obj[p[i]];
}
return true;
};
dojo.hostenv.normalizeLocale=function(_6e){
var _6f=_6e?_6e.toLowerCase():dojo.locale;
if(_6f=="root"){
_6f="ROOT";
}
return _6f;
};
dojo.hostenv.searchLocalePath=function(_70,_71,_72){
_70=dojo.hostenv.normalizeLocale(_70);
var _73=_70.split("-");
var _74=[];
for(var i=_73.length;i>0;i--){
_74.push(_73.slice(0,i).join("-"));
}
_74.push(false);
if(_71){
_74.reverse();
}
for(var j=_74.length-1;j>=0;j--){
var loc=_74[j]||"ROOT";
var _78=_72(loc);
if(_78){
break;
}
}
};
dojo.hostenv.localesGenerated;
dojo.hostenv.registerNlsPrefix=function(){
dojo.registerModulePath("nls","nls");
};
dojo.hostenv.preloadLocalizations=function(){
if(dojo.hostenv.localesGenerated){
dojo.hostenv.registerNlsPrefix();
function preload(_79){
_79=dojo.hostenv.normalizeLocale(_79);
dojo.hostenv.searchLocalePath(_79,true,function(loc){
for(var i=0;i<dojo.hostenv.localesGenerated.length;i++){
if(dojo.hostenv.localesGenerated[i]==loc){
dojo["require"]("nls.dojo_"+loc);
return true;
}
}
return false;
});
}
preload();
var _7c=djConfig.extraLocale||[];
for(var i=0;i<_7c.length;i++){
preload(_7c[i]);
}
}
dojo.hostenv.preloadLocalizations=function(){
};
};
dojo.requireLocalization=function(_7e,_7f,_80,_81){
dojo.hostenv.preloadLocalizations();
var _82=dojo.hostenv.normalizeLocale(_80);
var _83=[_7e,"nls",_7f].join(".");
var _84="";
if(_81){
var _85=_81.split(",");
for(var i=0;i<_85.length;i++){
if(_82.indexOf(_85[i])==0){
if(_85[i].length>_84.length){
_84=_85[i];
}
}
}
if(!_84){
_84="ROOT";
}
}
var _87=_81?_84:_82;
var _88=dojo.hostenv.findModule(_83);
var _89=null;
if(_88){
if(djConfig.localizationComplete&&_88._built){
return;
}
var _8a=_87.replace("-","_");
var _8b=_83+"."+_8a;
_89=dojo.hostenv.findModule(_8b);
}
if(!_89){
_88=dojo.hostenv.startPackage(_83);
var _8c=dojo.hostenv.getModuleSymbols(_7e);
var _8d=_8c.concat("nls").join("/");
var _8e;
dojo.hostenv.searchLocalePath(_87,_81,function(loc){
var _90=loc.replace("-","_");
var _91=_83+"."+_90;
var _92=false;
if(!dojo.hostenv.findModule(_91)){
dojo.hostenv.startPackage(_91);
var _93=[_8d];
if(loc!="ROOT"){
_93.push(loc);
}
_93.push(_7f);
var _94=_93.join("/")+".js";
_92=dojo.hostenv.loadPath(_94,null,function(_95){
var _96=function(){
};
_96.prototype=_8e;
_88[_90]=new _96();
for(var j in _95){
_88[_90][j]=_95[j];
}
});
}else{
_92=true;
}
if(_92&&_88[_90]){
_8e=_88[_90];
}else{
_88[_90]=_8e;
}
if(_81){
return true;
}
});
}
if(_81&&_82!=_84){
_88[_82.replace("-","_")]=_88[_84.replace("-","_")];
}
};
(function(){
var _98=djConfig.extraLocale;
if(_98){
if(!_98 instanceof Array){
_98=[_98];
}
var req=dojo.requireLocalization;
dojo.requireLocalization=function(m,b,_9c,_9d){
req(m,b,_9c,_9d);
if(_9c){
return;
}
for(var i=0;i<_98.length;i++){
req(m,b,_98[i],_9d);
}
};
}
})();
}
if(typeof window!="undefined"){
(function(){
if(djConfig.allowQueryConfig){
var _9f=document.location.toString();
var _a0=_9f.split("?",2);
if(_a0.length>1){
var _a1=_a0[1];
var _a2=_a1.split("&");
for(var x in _a2){
var sp=_a2[x].split("=");
if((sp[0].length>9)&&(sp[0].substr(0,9)=="djConfig.")){
var opt=sp[0].substr(9);
try{
djConfig[opt]=eval(sp[1]);
}
catch(e){
djConfig[opt]=sp[1];
}
}
}
}
}
if(((djConfig["baseScriptUri"]=="")||(djConfig["baseRelativePath"]==""))&&(document&&document.getElementsByTagName)){
var _a6=document.getElementsByTagName("script");
var _a7=/(__package__|dojo|bootstrap1)\.js([\?\.]|$)/i;
for(var i=0;i<_a6.length;i++){
var src=_a6[i].getAttribute("src");
if(!src){
continue;
}
var m=src.match(_a7);
if(m){
var _ab=src.substring(0,m.index);
if(src.indexOf("bootstrap1")>-1){
_ab+="../";
}
if(!this["djConfig"]){
djConfig={};
}
if(djConfig["baseScriptUri"]==""){
djConfig["baseScriptUri"]=_ab;
}
if(djConfig["baseRelativePath"]==""){
djConfig["baseRelativePath"]=_ab;
}
break;
}
}
}
var dr=dojo.render;
var drh=dojo.render.html;
var drs=dojo.render.svg;
var dua=(drh.UA=navigator.userAgent);
var dav=(drh.AV=navigator.appVersion);
var t=true;
var f=false;
drh.capable=t;
drh.support.builtin=t;
dr.ver=parseFloat(drh.AV);
dr.os.mac=dav.indexOf("Macintosh")>=0;
dr.os.win=dav.indexOf("Windows")>=0;
dr.os.linux=dav.indexOf("X11")>=0;
drh.opera=dua.indexOf("Opera")>=0;
drh.khtml=(dav.indexOf("Konqueror")>=0)||(dav.indexOf("Safari")>=0);
drh.safari=dav.indexOf("Safari")>=0;
var _b3=dua.indexOf("Gecko");
drh.mozilla=drh.moz=(_b3>=0)&&(!drh.khtml);
if(drh.mozilla){
drh.geckoVersion=dua.substring(_b3+6,_b3+14);
}
drh.ie=(document.all)&&(!drh.opera);
drh.ie50=drh.ie&&dav.indexOf("MSIE 5.0")>=0;
drh.ie55=drh.ie&&dav.indexOf("MSIE 5.5")>=0;
drh.ie60=drh.ie&&dav.indexOf("MSIE 6.0")>=0;
drh.ie70=drh.ie&&dav.indexOf("MSIE 7.0")>=0;
var cm=document["compatMode"];
drh.quirks=(cm=="BackCompat")||(cm=="QuirksMode")||drh.ie55||drh.ie50;
dojo.locale=dojo.locale||(drh.ie?navigator.userLanguage:navigator.language).toLowerCase();
dr.vml.capable=drh.ie;
drs.capable=f;
drs.support.plugin=f;
drs.support.builtin=f;
var _b5=window["document"];
var tdi=_b5["implementation"];
if((tdi)&&(tdi["hasFeature"])&&(tdi.hasFeature("org.w3c.dom.svg","1.0"))){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
if(drh.safari){
var tmp=dua.split("AppleWebKit/")[1];
var ver=parseFloat(tmp.split(" ")[0]);
if(ver>=420){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
}else{
}
})();
dojo.hostenv.startPackage("dojo.hostenv");
dojo.render.name=dojo.hostenv.name_="browser";
dojo.hostenv.searchIds=[];
dojo.hostenv._XMLHTTP_PROGIDS=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"];
dojo.hostenv.getXmlhttpObject=function(){
var _b9=null;
var _ba=null;
try{
_b9=new XMLHttpRequest();
}
catch(e){
}
if(!_b9){
for(var i=0;i<3;++i){
var _bc=dojo.hostenv._XMLHTTP_PROGIDS[i];
try{
_b9=new ActiveXObject(_bc);
}
catch(e){
_ba=e;
}
if(_b9){
dojo.hostenv._XMLHTTP_PROGIDS=[_bc];
break;
}
}
}
if(!_b9){
return dojo.raise("XMLHTTP not available",_ba);
}
return _b9;
};
dojo.hostenv._blockAsync=false;
dojo.hostenv.getText=function(uri,_be,_bf){
if(!_be){
this._blockAsync=true;
}
var _c0=this.getXmlhttpObject();
function isDocumentOk(_c1){
var _c2=_c1["status"];
return Boolean((!_c2)||((200<=_c2)&&(300>_c2))||(_c2==304));
}
if(_be){
var _c3=this,_c4=null,gbl=dojo.global();
var xhr=dojo.evalObjPath("dojo.io.XMLHTTPTransport");
_c0.onreadystatechange=function(){
if(_c4){
gbl.clearTimeout(_c4);
_c4=null;
}
if(_c3._blockAsync||(xhr&&xhr._blockAsync)){
_c4=gbl.setTimeout(function(){
_c0.onreadystatechange.apply(this);
},10);
}else{
if(4==_c0.readyState){
if(isDocumentOk(_c0)){
_be(_c0.responseText);
}
}
}
};
}
_c0.open("GET",uri,_be?true:false);
try{
_c0.send(null);
if(_be){
return null;
}
if(!isDocumentOk(_c0)){
var err=Error("Unable to load "+uri+" status:"+_c0.status);
err.status=_c0.status;
err.responseText=_c0.responseText;
throw err;
}
}
catch(e){
this._blockAsync=false;
if((_bf)&&(!_be)){
return null;
}else{
throw e;
}
}
this._blockAsync=false;
return _c0.responseText;
};
dojo.hostenv.defaultDebugContainerId="dojoDebug";
dojo.hostenv._println_buffer=[];
dojo.hostenv._println_safe=false;
dojo.hostenv.println=function(_c8){
if(!dojo.hostenv._println_safe){
dojo.hostenv._println_buffer.push(_c8);
}else{
try{
var _c9=document.getElementById(djConfig.debugContainerId?djConfig.debugContainerId:dojo.hostenv.defaultDebugContainerId);
if(!_c9){
_c9=dojo.body();
}
var div=document.createElement("div");
div.appendChild(document.createTextNode(_c8));
_c9.appendChild(div);
}
catch(e){
try{
document.write("<div>"+_c8+"</div>");
}
catch(e2){
window.status=_c8;
}
}
}
};
dojo.addOnLoad(function(){
dojo.hostenv._println_safe=true;
while(dojo.hostenv._println_buffer.length>0){
dojo.hostenv.println(dojo.hostenv._println_buffer.shift());
}
});
function dj_addNodeEvtHdlr(_cb,_cc,fp){
var _ce=_cb["on"+_cc]||function(){
};
_cb["on"+_cc]=function(){
fp.apply(_cb,arguments);
_ce.apply(_cb,arguments);
};
return true;
}
function dj_load_init(e){
var _d0=(e&&e.type)?e.type.toLowerCase():"load";
if(arguments.callee.initialized||(_d0!="domcontentloaded"&&_d0!="load")){
return;
}
arguments.callee.initialized=true;
if(typeof (_timer)!="undefined"){
clearInterval(_timer);
delete _timer;
}
var _d1=function(){
if(dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
};
if(dojo.hostenv.inFlightCount==0){
_d1();
dojo.hostenv.modulesLoaded();
}else{
dojo.hostenv.modulesLoadedListeners.unshift(_d1);
}
}
if(document.addEventListener){
if(dojo.render.html.opera||(dojo.render.html.moz&&!djConfig.delayMozLoadingFix)){
document.addEventListener("DOMContentLoaded",dj_load_init,null);
}
window.addEventListener("load",dj_load_init,null);
}
if(dojo.render.html.ie&&dojo.render.os.win){
document.attachEvent("onreadystatechange",function(e){
if(document.readyState=="complete"){
dj_load_init();
}
});
}
if(/(WebKit|khtml)/i.test(navigator.userAgent)){
var _timer=setInterval(function(){
if(/loaded|complete/.test(document.readyState)){
dj_load_init();
}
},10);
}
if(dojo.render.html.ie){
dj_addNodeEvtHdlr(window,"beforeunload",function(){
dojo.hostenv._unloading=true;
window.setTimeout(function(){
dojo.hostenv._unloading=false;
},0);
});
}
dj_addNodeEvtHdlr(window,"unload",function(){
dojo.hostenv.unloaded();
if((!dojo.render.html.ie)||(dojo.render.html.ie&&dojo.hostenv._unloading)){
dojo.hostenv.unloaded();
}
});
dojo.hostenv.makeWidgets=function(){
var _d3=[];
if(djConfig.searchIds&&djConfig.searchIds.length>0){
_d3=_d3.concat(djConfig.searchIds);
}
if(dojo.hostenv.searchIds&&dojo.hostenv.searchIds.length>0){
_d3=_d3.concat(dojo.hostenv.searchIds);
}
if((djConfig.parseWidgets)||(_d3.length>0)){
if(dojo.evalObjPath("dojo.widget.Parse")){
var _d4=new dojo.xml.Parse();
if(_d3.length>0){
for(var x=0;x<_d3.length;x++){
var _d6=document.getElementById(_d3[x]);
if(!_d6){
continue;
}
var _d7=_d4.parseElement(_d6,null,true);
dojo.widget.getParser().createComponents(_d7);
}
}else{
if(djConfig.parseWidgets){
var _d7=_d4.parseElement(dojo.body(),null,true);
dojo.widget.getParser().createComponents(_d7);
}
}
}
}
};
dojo.addOnLoad(function(){
if(!dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
});
try{
if(dojo.render.html.ie){
document.namespaces.add("v","urn:schemas-microsoft-com:vml");
document.createStyleSheet().addRule("v\\:*","behavior:url(#default#VML)");
}
}
catch(e){
}
dojo.hostenv.writeIncludes=function(){
};
if(!dj_undef("document",this)){
dj_currentDocument=this.document;
}
dojo.doc=function(){
return dj_currentDocument;
};
dojo.body=function(){
return dojo.doc().body||dojo.doc().getElementsByTagName("body")[0];
};
dojo.byId=function(id,doc){
if((id)&&((typeof id=="string")||(id instanceof String))){
if(!doc){
doc=dj_currentDocument;
}
var ele=doc.getElementById(id);
if(ele&&(ele.id!=id)&&doc.all){
ele=null;
eles=doc.all[id];
if(eles){
if(eles.length){
for(var i=0;i<eles.length;i++){
if(eles[i].id==id){
ele=eles[i];
break;
}
}
}else{
ele=eles;
}
}
}
return ele;
}
return id;
};
dojo.setContext=function(_dc,_dd){
dj_currentContext=_dc;
dj_currentDocument=_dd;
};
dojo._fireCallback=function(_de,_df,_e0){
if((_df)&&((typeof _de=="string")||(_de instanceof String))){
_de=_df[_de];
}
return (_df?_de.apply(_df,_e0||[]):_de());
};
dojo.withGlobal=function(_e1,_e2,_e3,_e4){
var _e5;
var _e6=dj_currentContext;
var _e7=dj_currentDocument;
try{
dojo.setContext(_e1,_e1.document);
_e5=dojo._fireCallback(_e2,_e3,_e4);
}
finally{
dojo.setContext(_e6,_e7);
}
return _e5;
};
dojo.withDoc=function(_e8,_e9,_ea,_eb){
var _ec;
var _ed=dj_currentDocument;
try{
dj_currentDocument=_e8;
_ec=dojo._fireCallback(_e9,_ea,_eb);
}
finally{
dj_currentDocument=_ed;
}
return _ec;
};
}
(function(){
if(typeof dj_usingBootstrap!="undefined"){
return;
}
var _ee=false;
var _ef=false;
var _f0=false;
if((typeof this["load"]=="function")&&((typeof this["Packages"]=="function")||(typeof this["Packages"]=="object"))){
_ee=true;
}else{
if(typeof this["load"]=="function"){
_ef=true;
}else{
if(window.widget){
_f0=true;
}
}
}
var _f1=[];
if((this["djConfig"])&&((djConfig["isDebug"])||(djConfig["debugAtAllCosts"]))){
_f1.push("debug.js");
}
if((this["djConfig"])&&(djConfig["debugAtAllCosts"])&&(!_ee)&&(!_f0)){
_f1.push("browser_debug.js");
}
var _f2=djConfig["baseScriptUri"];
if((this["djConfig"])&&(djConfig["baseLoaderUri"])){
_f2=djConfig["baseLoaderUri"];
}
for(var x=0;x<_f1.length;x++){
var _f4=_f2+"src/"+_f1[x];
if(_ee||_ef){
load(_f4);
}else{
try{
document.write("<scr"+"ipt type='text/javascript' src='"+_f4+"'></scr"+"ipt>");
}
catch(e){
var _f5=document.createElement("script");
_f5.src=_f4;
document.getElementsByTagName("head")[0].appendChild(_f5);
}
}
}
})();
dojo.provide("dojo.lang.common");
dojo.lang.inherits=function(_f6,_f7){
if(!dojo.lang.isFunction(_f7)){
dojo.raise("dojo.inherits: superclass argument ["+_f7+"] must be a function (subclass: ["+_f6+"']");
}
_f6.prototype=new _f7();
_f6.prototype.constructor=_f6;
_f6.superclass=_f7.prototype;
_f6["super"]=_f7.prototype;
};
dojo.lang._mixin=function(obj,_f9){
var _fa={};
for(var x in _f9){
if((typeof _fa[x]=="undefined")||(_fa[x]!=_f9[x])){
obj[x]=_f9[x];
}
}
if(dojo.render.html.ie&&(typeof (_f9["toString"])=="function")&&(_f9["toString"]!=obj["toString"])&&(_f9["toString"]!=_fa["toString"])){
obj.toString=_f9.toString;
}
return obj;
};
dojo.lang.mixin=function(obj,_fd){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(obj,arguments[i]);
}
return obj;
};
dojo.lang.extend=function(_100,_101){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(_100.prototype,arguments[i]);
}
return _100;
};
dojo.inherits=dojo.lang.inherits;
dojo.mixin=dojo.lang.mixin;
dojo.extend=dojo.lang.extend;
dojo.lang.find=function(_104,_105,_106,_107){
if(!dojo.lang.isArrayLike(_104)&&dojo.lang.isArrayLike(_105)){
dojo.deprecated("dojo.lang.find(value, array)","use dojo.lang.find(array, value) instead","0.5");
var temp=_104;
_104=_105;
_105=temp;
}
var _109=dojo.lang.isString(_104);
if(_109){
_104=_104.split("");
}
if(_107){
var step=-1;
var i=_104.length-1;
var end=-1;
}else{
var step=1;
var i=0;
var end=_104.length;
}
if(_106){
while(i!=end){
if(_104[i]===_105){
return i;
}
i+=step;
}
}else{
while(i!=end){
if(_104[i]==_105){
return i;
}
i+=step;
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(_10d,_10e,_10f){
return dojo.lang.find(_10d,_10e,_10f,true);
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(_110,_111){
return dojo.lang.find(_110,_111)>-1;
};
dojo.lang.isObject=function(it){
if(typeof it=="undefined"){
return false;
}
return (typeof it=="object"||it===null||dojo.lang.isArray(it)||dojo.lang.isFunction(it));
};
dojo.lang.isArray=function(it){
return (it&&it instanceof Array||typeof it=="array");
};
dojo.lang.isArrayLike=function(it){
if((!it)||(dojo.lang.isUndefined(it))){
return false;
}
if(dojo.lang.isString(it)){
return false;
}
if(dojo.lang.isFunction(it)){
return false;
}
if(dojo.lang.isArray(it)){
return true;
}
if((it.tagName)&&(it.tagName.toLowerCase()=="form")){
return false;
}
if(dojo.lang.isNumber(it.length)&&isFinite(it.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(it){
return (it instanceof Function||typeof it=="function");
};
(function(){
if((dojo.render.html.capable)&&(dojo.render.html["safari"])){
dojo.lang.isFunction=function(it){
if((typeof (it)=="function")&&(it=="[object NodeList]")){
return false;
}
return (it instanceof Function||typeof it=="function");
};
}
})();
dojo.lang.isString=function(it){
return (typeof it=="string"||it instanceof String);
};
dojo.lang.isAlien=function(it){
if(!it){
return false;
}
return !dojo.lang.isFunction(it)&&/\{\s*\[native code\]\s*\}/.test(String(it));
};
dojo.lang.isBoolean=function(it){
return (it instanceof Boolean||typeof it=="boolean");
};
dojo.lang.isNumber=function(it){
return (it instanceof Number||typeof it=="number");
};
dojo.lang.isUndefined=function(it){
return ((typeof (it)=="undefined")&&(it==undefined));
};
dojo.provide("dojo.lang.func");
dojo.lang.hitch=function(_11c,_11d){
var fcn=(dojo.lang.isString(_11d)?_11c[_11d]:_11d)||function(){
};
return function(){
return fcn.apply(_11c,arguments);
};
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_11f,_120,_121){
var nso=(_120||dojo.lang.anon);
if((_121)||((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true))){
for(var x in nso){
try{
if(nso[x]===_11f){
return x;
}
}
catch(e){
}
}
}
var ret="__"+dojo.lang.anonCtr++;
while(typeof nso[ret]!="undefined"){
ret="__"+dojo.lang.anonCtr++;
}
nso[ret]=_11f;
return ret;
};
dojo.lang.forward=function(_125){
return function(){
return this[_125].apply(this,arguments);
};
};
dojo.lang.curry=function(_126,func){
var _128=[];
_126=_126||dj_global;
if(dojo.lang.isString(func)){
func=_126[func];
}
for(var x=2;x<arguments.length;x++){
_128.push(arguments[x]);
}
var _12a=(func["__preJoinArity"]||func.length)-_128.length;
function gather(_12b,_12c,_12d){
var _12e=_12d;
var _12f=_12c.slice(0);
for(var x=0;x<_12b.length;x++){
_12f.push(_12b[x]);
}
_12d=_12d-_12b.length;
if(_12d<=0){
var res=func.apply(_126,_12f);
_12d=_12e;
return res;
}else{
return function(){
return gather(arguments,_12f,_12d);
};
}
}
return gather([],_128,_12a);
};
dojo.lang.curryArguments=function(_132,func,args,_135){
var _136=[];
var x=_135||0;
for(x=_135;x<args.length;x++){
_136.push(args[x]);
}
return dojo.lang.curry.apply(dojo.lang,[_132,func].concat(_136));
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(farr,cb,_13c,_13d){
if(!farr.length){
if(typeof _13d=="function"){
_13d();
}
return;
}
if((typeof _13c=="undefined")&&(typeof cb=="number")){
_13c=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_13c){
_13c=0;
}
}
}
setTimeout(function(){
(farr.shift())();
cb();
dojo.lang.delayThese(farr,cb,_13c,_13d);
},_13c);
};
dojo.provide("dojo.string.common");
dojo.string.trim=function(str,wh){
if(!str.replace){
return str;
}
if(!str.length){
return str;
}
var re=(wh>0)?(/^\s+/):(wh<0)?(/\s+$/):(/^\s+|\s+$/g);
return str.replace(re,"");
};
dojo.string.trimStart=function(str){
return dojo.string.trim(str,1);
};
dojo.string.trimEnd=function(str){
return dojo.string.trim(str,-1);
};
dojo.string.repeat=function(str,_144,_145){
var out="";
for(var i=0;i<_144;i++){
out+=str;
if(_145&&i<_144-1){
out+=_145;
}
}
return out;
};
dojo.string.pad=function(str,len,c,dir){
var out=String(str);
if(!c){
c="0";
}
if(!dir){
dir=1;
}
while(out.length<len){
if(dir>0){
out=c+out;
}else{
out+=c;
}
}
return out;
};
dojo.string.padLeft=function(str,len,c){
return dojo.string.pad(str,len,c,1);
};
dojo.string.padRight=function(str,len,c){
return dojo.string.pad(str,len,c,-1);
};
dojo.provide("dojo.lang.array");
dojo.lang.mixin(dojo.lang,{has:function(obj,name){
try{
return typeof obj[name]!="undefined";
}
catch(e){
return false;
}
},isEmpty:function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _157=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_157++;
break;
}
}
return _157==0;
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
},map:function(arr,obj,_15b){
var _15c=dojo.lang.isString(arr);
if(_15c){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_15b)){
_15b=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_15b){
var _15d=obj;
obj=_15b;
_15b=_15d;
}
}
if(Array.map){
var _15e=Array.map(arr,_15b,obj);
}else{
var _15e=[];
for(var i=0;i<arr.length;++i){
_15e.push(_15b.call(obj,arr[i]));
}
}
if(_15c){
return _15e.join("");
}else{
return _15e;
}
},reduce:function(arr,_161,obj,_163){
var _164=_161;
if(arguments.length==1){
dojo.debug("dojo.lang.reduce called with too few arguments!");
return false;
}else{
if(arguments.length==2){
_163=_161;
_164=arr.shift();
}else{
if(arguments.lenght==3){
if(dojo.lang.isFunction(obj)){
_163=obj;
obj=null;
}
}else{
if(dojo.lang.isFunction(obj)){
var tmp=_163;
_163=obj;
obj=tmp;
}
}
}
}
var ob=obj?obj:dj_global;
dojo.lang.map(arr,function(val){
_164=_163.call(ob,_164,val);
});
return _164;
},forEach:function(_168,_169,_16a){
if(dojo.lang.isString(_168)){
_168=_168.split("");
}
if(Array.forEach){
Array.forEach(_168,_169,_16a);
}else{
if(!_16a){
_16a=dj_global;
}
for(var i=0,l=_168.length;i<l;i++){
_169.call(_16a,_168[i],i,_168);
}
}
},_everyOrSome:function(_16d,arr,_16f,_170){
if(dojo.lang.isString(arr)){
arr=arr.split("");
}
if(Array.every){
return Array[_16d?"every":"some"](arr,_16f,_170);
}else{
if(!_170){
_170=dj_global;
}
for(var i=0,l=arr.length;i<l;i++){
var _173=_16f.call(_170,arr[i],i,arr);
if(_16d&&!_173){
return false;
}else{
if((!_16d)&&(_173)){
return true;
}
}
}
return Boolean(_16d);
}
},every:function(arr,_175,_176){
return this._everyOrSome(true,arr,_175,_176);
},some:function(arr,_178,_179){
return this._everyOrSome(false,arr,_178,_179);
},filter:function(arr,_17b,_17c){
var _17d=dojo.lang.isString(arr);
if(_17d){
arr=arr.split("");
}
var _17e;
if(Array.filter){
_17e=Array.filter(arr,_17b,_17c);
}else{
if(!_17c){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_17c=dj_global;
}
_17e=[];
for(var i=0;i<arr.length;i++){
if(_17b.call(_17c,arr[i],i,arr)){
_17e.push(arr[i]);
}
}
}
if(_17d){
return _17e.join("");
}else{
return _17e;
}
},unnest:function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
},toArray:function(_183,_184){
var _185=[];
for(var i=_184||0;i<_183.length;i++){
_185.push(_183[i]);
}
return _185;
}});
dojo.provide("dojo.string.extras");
dojo.string.substituteParams=function(_187,hash){
var map=(typeof hash=="object")?hash:dojo.lang.toArray(arguments,1);
return _187.replace(/\%\{(\w+)\}/g,function(_18a,key){
if(typeof (map[key])!="undefined"&&map[key]!=null){
return map[key];
}
dojo.raise("Substitution not found: "+key);
});
};
dojo.string.capitalize=function(str){
if(!dojo.lang.isString(str)){
return "";
}
if(arguments.length==0){
str=this;
}
var _18d=str.split(" ");
for(var i=0;i<_18d.length;i++){
_18d[i]=_18d[i].charAt(0).toUpperCase()+_18d[i].substring(1);
}
return _18d.join(" ");
};
dojo.string.isBlank=function(str){
if(!dojo.lang.isString(str)){
return true;
}
return (dojo.string.trim(str).length==0);
};
dojo.string.encodeAscii=function(str){
if(!dojo.lang.isString(str)){
return str;
}
var ret="";
var _192=escape(str);
var _193,re=/%u([0-9A-F]{4})/i;
while((_193=_192.match(re))){
var num=Number("0x"+_193[1]);
var _196=escape("&#"+num+";");
ret+=_192.substring(0,_193.index)+_196;
_192=_192.substring(_193.index+_193[0].length);
}
ret+=_192.replace(/\+/g,"%2B");
return ret;
};
dojo.string.escape=function(type,str){
var args=dojo.lang.toArray(arguments,1);
switch(type.toLowerCase()){
case "xml":
case "html":
case "xhtml":
return dojo.string.escapeXml.apply(this,args);
case "sql":
return dojo.string.escapeSql.apply(this,args);
case "regexp":
case "regex":
return dojo.string.escapeRegExp.apply(this,args);
case "javascript":
case "jscript":
case "js":
return dojo.string.escapeJavaScript.apply(this,args);
case "ascii":
return dojo.string.encodeAscii.apply(this,args);
default:
return str;
}
};
dojo.string.escapeXml=function(str,_19b){
str=str.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;");
if(!_19b){
str=str.replace(/'/gm,"&#39;");
}
return str;
};
dojo.string.escapeSql=function(str){
return str.replace(/'/gm,"''");
};
dojo.string.escapeRegExp=function(str){
return str.replace(/\\/gm,"\\\\").replace(/([\f\b\n\t\r[\^$|?*+(){}])/gm,"\\$1");
};
dojo.string.escapeJavaScript=function(str){
return str.replace(/(["'\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.escapeString=function(str){
return ("\""+str.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r");
};
dojo.string.summary=function(str,len){
if(!len||str.length<=len){
return str;
}
return str.substring(0,len).replace(/\.+$/,"")+"...";
};
dojo.string.endsWith=function(str,end,_1a4){
if(_1a4){
str=str.toLowerCase();
end=end.toLowerCase();
}
if((str.length-end.length)<0){
return false;
}
return str.lastIndexOf(end)==str.length-end.length;
};
dojo.string.endsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.endsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.startsWith=function(str,_1a8,_1a9){
if(_1a9){
str=str.toLowerCase();
_1a8=_1a8.toLowerCase();
}
return str.indexOf(_1a8)==0;
};
dojo.string.startsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.startsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.has=function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i])>-1){
return true;
}
}
return false;
};
dojo.string.normalizeNewlines=function(text,_1af){
if(_1af=="\n"){
text=text.replace(/\r\n/g,"\n");
text=text.replace(/\r/g,"\n");
}else{
if(_1af=="\r"){
text=text.replace(/\r\n/g,"\r");
text=text.replace(/\n/g,"\r");
}else{
text=text.replace(/([^\r])\n/g,"$1\r\n").replace(/\r([^\n])/g,"\r\n$1");
}
}
return text;
};
dojo.string.splitEscaped=function(str,_1b1){
var _1b2=[];
for(var i=0,_1b4=0;i<str.length;i++){
if(str.charAt(i)=="\\"){
i++;
continue;
}
if(str.charAt(i)==_1b1){
_1b2.push(str.substring(_1b4,i));
_1b4=i+1;
}
}
_1b2.push(str.substr(_1b4));
return _1b2;
};
dojo.provide("dojo.AdapterRegistry");
dojo.AdapterRegistry=function(_1b5){
this.pairs=[];
this.returnWrappers=_1b5||false;
};
dojo.lang.extend(dojo.AdapterRegistry,{register:function(name,_1b7,wrap,_1b9,_1ba){
var type=(_1ba)?"unshift":"push";
this.pairs[type]([name,_1b7,wrap,_1b9]);
},match:function(){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[1].apply(this,arguments)){
if((pair[3])||(this.returnWrappers)){
return pair[2];
}else{
return pair[2].apply(this,arguments);
}
}
}
throw new Error("No match found");
},unregister:function(name){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[0]==name){
this.pairs.splice(i,1);
return true;
}
}
return false;
}});
dojo.provide("dojo.json");
dojo.json={jsonRegistry:new dojo.AdapterRegistry(),register:function(name,_1c2,wrap,_1c4){
dojo.json.jsonRegistry.register(name,_1c2,wrap,_1c4);
},evalJson:function(json){
try{
return eval("("+json+")");
}
catch(e){
dojo.debug(e);
return json;
}
},serialize:function(o){
var _1c7=typeof (o);
if(_1c7=="undefined"){
return "undefined";
}else{
if((_1c7=="number")||(_1c7=="boolean")){
return o+"";
}else{
if(o===null){
return "null";
}
}
}
if(_1c7=="string"){
return dojo.string.escapeString(o);
}
var me=arguments.callee;
var _1c9;
if(typeof (o.__json__)=="function"){
_1c9=o.__json__();
if(o!==_1c9){
return me(_1c9);
}
}
if(typeof (o.json)=="function"){
_1c9=o.json();
if(o!==_1c9){
return me(_1c9);
}
}
if(_1c7!="function"&&typeof (o.length)=="number"){
var res=[];
for(var i=0;i<o.length;i++){
var val=me(o[i]);
if(typeof (val)!="string"){
val="undefined";
}
res.push(val);
}
return "["+res.join(",")+"]";
}
try{
window.o=o;
_1c9=dojo.json.jsonRegistry.match(o);
return me(_1c9);
}
catch(e){
}
if(_1c7=="function"){
return null;
}
res=[];
for(var k in o){
var _1ce;
if(typeof (k)=="number"){
_1ce="\""+k+"\"";
}else{
if(typeof (k)=="string"){
_1ce=dojo.string.escapeString(k);
}else{
continue;
}
}
val=me(o[k]);
if(typeof (val)!="string"){
continue;
}
res.push(_1ce+":"+val);
}
return "{"+res.join(",")+"}";
}};
dojo.provide("dojo.collections.Store");
dojo.collections.Store=function(_1cf){
var data=[];
this.keyField="Id";
this.get=function(){
return data;
};
this.getByKey=function(key){
for(var i=0;i<data.length;i++){
if(data[i].key==key){
return data[i];
}
}
return null;
};
this.getByIndex=function(idx){
return data[idx];
};
this.getData=function(){
var arr=[];
for(var i=0;i<data.length;i++){
arr.push(data[i].src);
}
return arr;
};
this.getDataByKey=function(key){
for(var i=0;i<data.length;i++){
if(data[i].key==key){
return data[i].src;
}
}
return null;
};
this.getDataByIndex=function(idx){
return data[idx].src;
};
this.update=function(obj,_1da,val){
var _1dc=_1da.split("."),i=0,o=obj,_1df;
if(_1dc.length>1){
_1df=_1dc.pop();
do{
if(_1dc[i].indexOf("()")>-1){
var temp=_1dc[i++].split("()")[0];
if(!o[temp]){
dojo.raise("dojo.collections.Store.getField(obj, '"+_1df+"'): '"+temp+"' is not a property of the passed object.");
}else{
o=o[temp]();
}
}else{
o=o[_1dc[i++]];
}
}while(i<_1dc.length&&o!=null);
}else{
_1df=_1dc[0];
}
obj[_1df]=val;
this.onUpdateField(obj,_1da,val);
};
this.forEach=function(fn){
if(Array.forEach){
Array.forEach(data,fn,this);
}else{
for(var i=0;i<data.length;i++){
fn.call(this,data[i]);
}
}
};
this.forEachData=function(fn){
if(Array.forEach){
Array.forEach(this.getData(),fn,this);
}else{
var a=this.getData();
for(var i=0;i<a.length;i++){
fn.call(this,a[i]);
}
}
};
this.setData=function(arr){
data=[];
for(var i=0;i<arr.length;i++){
data.push({key:arr[i][this.keyField],src:arr[i]});
}
this.onSetData();
};
this.clearData=function(){
data=[];
this.onClearData();
};
this.addData=function(obj,key){
var k=key||obj[this.keyField];
if(this.getByKey(k)){
var o=this.getByKey(k);
o.src=obj;
}else{
var o={key:k,src:obj};
data.push(o);
}
this.onAddData(o);
};
this.addDataRange=function(arr){
var _1ed=[];
for(var i=0;i<arr.length;i++){
var k=arr[i][this.keyField];
if(this.getByKey(k)){
var o=this.getByKey(k);
o.src=obj;
}else{
var o={key:k,src:arr[i]};
data.push(o);
}
_1ed.push(o);
}
this.onAddDataRange(_1ed);
};
this.removeData=function(obj){
var idx=-1;
var o=null;
for(var i=0;i<data.length;i++){
if(data[i].src==obj){
idx=i;
o=data[i];
break;
}
}
this.onRemoveData(o);
if(idx>-1){
data.splice(idx,1);
}
};
this.removeDataByKey=function(key){
this.removeData(this.getDataByKey(key));
};
this.removeDataByIndex=function(idx){
this.removeData(this.getDataByIndex(idx));
};
if(_1cf&&_1cf.length&&_1cf[0]){
this.setData(_1cf);
}
};
dojo.extend(dojo.collections.Store,{getField:function(obj,_1f8){
var _1f9=_1f8.split("."),i=0,o=obj;
do{
if(_1f9[i].indexOf("()")>-1){
var temp=_1f9[i++].split("()")[0];
if(!o[temp]){
dojo.raise("dojo.collections.Store.getField(obj, '"+_1f8+"'): '"+temp+"' is not a property of the passed object.");
}else{
o=o[temp]();
}
}else{
o=o[_1f9[i++]];
}
}while(i<_1f9.length&&o!=null);
if(i<_1f9.length){
dojo.raise("dojo.collections.Store.getField(obj, '"+_1f8+"'): '"+_1f8+"' is not a property of the passed object.");
}
return o;
},getFromHtml:function(meta,body,_1ff){
var rows=body.rows;
var ctor=function(row){
var obj={};
for(var i=0;i<meta.length;i++){
var o=obj;
var data=row.cells[i].innerHTML;
var p=meta[i].getField();
if(p.indexOf(".")>-1){
p=p.split(".");
while(p.length>1){
var pr=p.shift();
o[pr]={};
o=o[pr];
}
p=p[0];
}
var type=meta[i].getType();
if(type==String){
o[p]=data;
}else{
if(data){
o[p]=new type(data);
}else{
o[p]=new type();
}
}
}
return obj;
};
var arr=[];
for(var i=0;i<rows.length;i++){
var o=ctor(rows[i]);
if(_1ff){
_1ff(o,rows[i]);
}
arr.push(o);
}
return arr;
},onSetData:function(){
},onClearData:function(){
},onAddData:function(obj){
},onAddDataRange:function(arr){
},onRemoveData:function(obj){
},onUpdateField:function(obj,_211,val){
}});
dojo.provide("dojo.gfx.color");
dojo.gfx.color.Color=function(r,g,b,a){
if(dojo.lang.isArray(r)){
this.r=r[0];
this.g=r[1];
this.b=r[2];
this.a=r[3]||1;
}else{
if(dojo.lang.isString(r)){
var rgb=dojo.gfx.color.extractRGB(r);
this.r=rgb[0];
this.g=rgb[1];
this.b=rgb[2];
this.a=g||1;
}else{
if(r instanceof dojo.gfx.color.Color){
this.r=r.r;
this.b=r.b;
this.g=r.g;
this.a=r.a;
}else{
this.r=r;
this.g=g;
this.b=b;
this.a=a;
}
}
}
};
dojo.gfx.color.Color.fromArray=function(arr){
return new dojo.gfx.color.Color(arr[0],arr[1],arr[2],arr[3]);
};
dojo.extend(dojo.gfx.color.Color,{toRgb:function(_219){
if(_219){
return this.toRgba();
}else{
return [this.r,this.g,this.b];
}
},toRgba:function(){
return [this.r,this.g,this.b,this.a];
},toHex:function(){
return dojo.gfx.color.rgb2hex(this.toRgb());
},toCss:function(){
return "rgb("+this.toRgb().join()+")";
},toString:function(){
return this.toHex();
},blend:function(_21a,_21b){
var rgb=null;
if(dojo.lang.isArray(_21a)){
rgb=_21a;
}else{
if(_21a instanceof dojo.gfx.color.Color){
rgb=_21a.toRgb();
}else{
rgb=new dojo.gfx.color.Color(_21a).toRgb();
}
}
return dojo.gfx.color.blend(this.toRgb(),rgb,_21b);
}});
dojo.gfx.color.named={white:[255,255,255],black:[0,0,0],red:[255,0,0],green:[0,255,0],lime:[0,255,0],blue:[0,0,255],navy:[0,0,128],gray:[128,128,128],silver:[192,192,192]};
dojo.gfx.color.blend=function(a,b,_21f){
if(typeof a=="string"){
return dojo.gfx.color.blendHex(a,b,_21f);
}
if(!_21f){
_21f=0;
}
_21f=Math.min(Math.max(-1,_21f),1);
_21f=((_21f+1)/2);
var c=[];
for(var x=0;x<3;x++){
c[x]=parseInt(b[x]+((a[x]-b[x])*_21f));
}
return c;
};
dojo.gfx.color.blendHex=function(a,b,_224){
return dojo.gfx.color.rgb2hex(dojo.gfx.color.blend(dojo.gfx.color.hex2rgb(a),dojo.gfx.color.hex2rgb(b),_224));
};
dojo.gfx.color.extractRGB=function(_225){
var hex="0123456789abcdef";
_225=_225.toLowerCase();
if(_225.indexOf("rgb")==0){
var _227=_225.match(/rgba*\((\d+), *(\d+), *(\d+)/i);
var ret=_227.splice(1,3);
return ret;
}else{
var _229=dojo.gfx.color.hex2rgb(_225);
if(_229){
return _229;
}else{
return dojo.gfx.color.named[_225]||[255,255,255];
}
}
};
dojo.gfx.color.hex2rgb=function(hex){
var _22b="0123456789ABCDEF";
var rgb=new Array(3);
if(hex.indexOf("#")==0){
hex=hex.substring(1);
}
hex=hex.toUpperCase();
if(hex.replace(new RegExp("["+_22b+"]","g"),"")!=""){
return null;
}
if(hex.length==3){
rgb[0]=hex.charAt(0)+hex.charAt(0);
rgb[1]=hex.charAt(1)+hex.charAt(1);
rgb[2]=hex.charAt(2)+hex.charAt(2);
}else{
rgb[0]=hex.substring(0,2);
rgb[1]=hex.substring(2,4);
rgb[2]=hex.substring(4);
}
for(var i=0;i<rgb.length;i++){
rgb[i]=_22b.indexOf(rgb[i].charAt(0))*16+_22b.indexOf(rgb[i].charAt(1));
}
return rgb;
};
dojo.gfx.color.rgb2hex=function(r,g,b){
if(dojo.lang.isArray(r)){
g=r[1]||0;
b=r[2]||0;
r=r[0]||0;
}
var ret=dojo.lang.map([r,g,b],function(x){
x=new Number(x);
var s=x.toString(16);
while(s.length<2){
s="0"+s;
}
return s;
});
ret.unshift("#");
return ret.join("");
};
dojo.provide("dojo.gfx.color.hsl");
dojo.lang.extend(dojo.gfx.color.Color,{toHsl:function(){
return dojo.gfx.color.rgb2hsl(this.toRgb());
}});
dojo.gfx.color.rgb2hsl=function(r,g,b){
if(dojo.lang.isArray(r)){
b=r[2]||0;
g=r[1]||0;
r=r[0]||0;
}
r/=255;
g/=255;
b/=255;
var h=null;
var s=null;
var l=null;
var min=Math.min(r,g,b);
var max=Math.max(r,g,b);
var _23c=max-min;
l=(min+max)/2;
s=0;
if((l>0)&&(l<1)){
s=_23c/((l<0.5)?(2*l):(2-2*l));
}
h=0;
if(_23c>0){
if((max==r)&&(max!=g)){
h+=(g-b)/_23c;
}
if((max==g)&&(max!=b)){
h+=(2+(b-r)/_23c);
}
if((max==b)&&(max!=r)){
h+=(4+(r-g)/_23c);
}
h*=60;
}
h=(h==0)?360:Math.ceil((h/360)*255);
s=Math.ceil(s*255);
l=Math.ceil(l*255);
return [h,s,l];
};
dojo.gfx.color.hsl2rgb=function(h,s,l){
if(dojo.lang.isArray(h)){
l=h[2]||0;
s=h[1]||0;
h=h[0]||0;
}
h=(h/255)*360;
if(h==360){
h=0;
}
s=s/255;
l=l/255;
while(h<0){
h+=360;
}
while(h>360){
h-=360;
}
var r,g,b;
if(h<120){
r=(120-h)/60;
g=h/60;
b=0;
}else{
if(h<240){
r=0;
g=(240-h)/60;
b=(h-120)/60;
}else{
r=(h-240)/60;
g=0;
b=(360-h)/60;
}
}
r=Math.min(r,1);
g=Math.min(g,1);
b=Math.min(b,1);
r=2*s*r+(1-s);
g=2*s*g+(1-s);
b=2*s*b+(1-s);
if(l<0.5){
r=l*r;
g=l*g;
b=l*b;
}else{
r=(1-l)*r+2*l-1;
g=(1-l)*g+2*l-1;
b=(1-l)*b+2*l-1;
}
r=Math.ceil(r*255);
g=Math.ceil(g*255);
b=Math.ceil(b*255);
return [r,g,b];
};
dojo.gfx.color.hsl2hex=function(h,s,l){
var rgb=dojo.gfx.color.hsl2rgb(h,s,l);
return dojo.gfx.color.rgb2hex(rgb[0],rgb[1],rgb[2]);
};
dojo.gfx.color.hex2hsl=function(hex){
var rgb=dojo.gfx.color.hex2rgb(hex);
return dojo.gfx.color.rgb2hsl(rgb[0],rgb[1],rgb[2]);
};
dojo.provide("dojo.charting.*");
dojo.provide("dojo.dom");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=function(wh){
if(typeof Element=="function"){
try{
return wh instanceof Element;
}
catch(e){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.dom.getUniqueId=function(){
var _24a=dojo.doc();
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(_24a.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_24c,_24d){
var node=_24c.firstChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.nextSibling;
}
if(_24d&&node&&node.tagName&&node.tagName.toLowerCase()!=_24d.toLowerCase()){
node=dojo.dom.nextElement(node,_24d);
}
return node;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_24f,_250){
var node=_24f.lastChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.previousSibling;
}
if(_250&&node&&node.tagName&&node.tagName.toLowerCase()!=_250.toLowerCase()){
node=dojo.dom.prevElement(node,_250);
}
return node;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(node,_253){
if(!node){
return null;
}
do{
node=node.nextSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_253&&_253.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.nextElement(node,_253);
}
return node;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(node,_255){
if(!node){
return null;
}
if(_255){
_255=_255.toLowerCase();
}
do{
node=node.previousSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_255&&_255.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.prevElement(node,_255);
}
return node;
};
dojo.dom.moveChildren=function(_256,_257,trim){
var _259=0;
if(trim){
while(_256.hasChildNodes()&&_256.firstChild.nodeType==dojo.dom.TEXT_NODE){
_256.removeChild(_256.firstChild);
}
while(_256.hasChildNodes()&&_256.lastChild.nodeType==dojo.dom.TEXT_NODE){
_256.removeChild(_256.lastChild);
}
}
while(_256.hasChildNodes()){
_257.appendChild(_256.firstChild);
_259++;
}
return _259;
};
dojo.dom.copyChildren=function(_25a,_25b,trim){
var _25d=_25a.cloneNode(true);
return this.moveChildren(_25d,_25b,trim);
};
dojo.dom.replaceChildren=function(node,_25f){
var _260=[];
if(dojo.render.html.ie){
for(var i=0;i<node.childNodes.length;i++){
_260.push(node.childNodes[i]);
}
}
dojo.dom.removeChildren(node);
node.appendChild(_25f);
for(var i=0;i<_260.length;i++){
dojo.dom.destroyNode(_260[i]);
}
};
dojo.dom.removeChildren=function(node){
var _263=node.childNodes.length;
while(node.hasChildNodes()){
dojo.dom.removeNode(node.firstChild);
}
return _263;
};
dojo.dom.replaceNode=function(node,_265){
return node.parentNode.replaceChild(_265,node);
};
dojo.dom.destroyNode=function(node){
if(node.parentNode){
node=dojo.dom.removeNode(node);
}
if(node.nodeType!=3){
if(dojo.evalObjPath("dojo.event.browser.clean",false)){
dojo.event.browser.clean(node);
}
if(dojo.render.html.ie){
node.outerHTML="";
}
}
};
dojo.dom.removeNode=function(node){
if(node&&node.parentNode){
return node.parentNode.removeChild(node);
}
};
dojo.dom.getAncestors=function(node,_269,_26a){
var _26b=[];
var _26c=(_269&&(_269 instanceof Function||typeof _269=="function"));
while(node){
if(!_26c||_269(node)){
_26b.push(node);
}
if(_26a&&_26b.length>0){
return _26b[0];
}
node=node.parentNode;
}
if(_26a){
return null;
}
return _26b;
};
dojo.dom.getAncestorsByTag=function(node,tag,_26f){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(node,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_26f);
};
dojo.dom.getFirstAncestorByTag=function(node,tag){
return dojo.dom.getAncestorsByTag(node,tag,true);
};
dojo.dom.isDescendantOf=function(node,_274,_275){
if(_275&&node){
node=node.parentNode;
}
while(node){
if(node==_274){
return true;
}
node=node.parentNode;
}
return false;
};
dojo.dom.innerXML=function(node){
if(node.innerXML){
return node.innerXML;
}else{
if(node.xml){
return node.xml;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(node);
}
}
}
};
dojo.dom.createDocument=function(){
var doc=null;
var _278=dojo.doc();
if(!dj_undef("ActiveXObject")){
var _279=["MSXML2","Microsoft","MSXML","MSXML3"];
for(var i=0;i<_279.length;i++){
try{
doc=new ActiveXObject(_279[i]+".XMLDOM");
}
catch(e){
}
if(doc){
break;
}
}
}else{
if((_278.implementation)&&(_278.implementation.createDocument)){
doc=_278.implementation.createDocument("","",null);
}
}
return doc;
};
dojo.dom.createDocumentFromText=function(str,_27c){
if(!_27c){
_27c="text/xml";
}
if(!dj_undef("DOMParser")){
var _27d=new DOMParser();
return _27d.parseFromString(str,_27c);
}else{
if(!dj_undef("ActiveXObject")){
var _27e=dojo.dom.createDocument();
if(_27e){
_27e.async=false;
_27e.loadXML(str);
return _27e;
}else{
dojo.debug("toXml didn't work?");
}
}else{
var _27f=dojo.doc();
if(_27f.createElement){
var tmp=_27f.createElement("xml");
tmp.innerHTML=str;
if(_27f.implementation&&_27f.implementation.createDocument){
var _281=_27f.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_281.importNode(tmp.childNodes.item(i),true);
}
return _281;
}
return ((tmp.document)&&(tmp.document.firstChild?tmp.document.firstChild:tmp));
}
}
}
return null;
};
dojo.dom.prependChild=function(node,_284){
if(_284.firstChild){
_284.insertBefore(node,_284.firstChild);
}else{
_284.appendChild(node);
}
return true;
};
dojo.dom.insertBefore=function(node,ref,_287){
if((_287!=true)&&(node===ref||node.nextSibling===ref)){
return false;
}
var _288=ref.parentNode;
_288.insertBefore(node,ref);
return true;
};
dojo.dom.insertAfter=function(node,ref,_28b){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_28b!=true)&&(node===ref)){
return false;
}
pn.appendChild(node);
}else{
return this.insertBefore(node,ref.nextSibling,_28b);
}
return true;
};
dojo.dom.insertAtPosition=function(node,ref,_28f){
if((!node)||(!ref)||(!_28f)){
return false;
}
switch(_28f.toLowerCase()){
case "before":
return dojo.dom.insertBefore(node,ref);
case "after":
return dojo.dom.insertAfter(node,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(node,ref.firstChild);
}else{
ref.appendChild(node);
return true;
}
break;
default:
ref.appendChild(node);
return true;
}
};
dojo.dom.insertAtIndex=function(node,_291,_292){
var _293=_291.childNodes;
if(!_293.length||_293.length==_292){
_291.appendChild(node);
return true;
}
if(_292==0){
return dojo.dom.prependChild(node,_291);
}
return dojo.dom.insertAfter(node,_293[_292-1]);
};
dojo.dom.textContent=function(node,text){
if(arguments.length>1){
var _296=dojo.doc();
dojo.dom.replaceChildren(node,_296.createTextNode(text));
return text;
}else{
if(node.textContent!=undefined){
return node.textContent;
}
var _297="";
if(node==null){
return _297;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
_297+=dojo.dom.textContent(node.childNodes[i]);
break;
case 3:
case 2:
case 4:
_297+=node.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _297;
}
};
dojo.dom.hasParent=function(node){
return Boolean(node&&node.parentNode&&dojo.dom.isNode(node.parentNode));
};
dojo.dom.isTag=function(node){
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName==String(arguments[i])){
return String(arguments[i]);
}
}
}
return "";
};
dojo.dom.setAttributeNS=function(elem,_29d,_29e,_29f){
if(elem==null||((elem==undefined)&&(typeof elem=="undefined"))){
dojo.raise("No element given to dojo.dom.setAttributeNS");
}
if(!((elem.setAttributeNS==undefined)&&(typeof elem.setAttributeNS=="undefined"))){
elem.setAttributeNS(_29d,_29e,_29f);
}else{
var _2a0=elem.ownerDocument;
var _2a1=_2a0.createNode(2,_29e,_29d);
_2a1.nodeValue=_29f;
elem.setAttributeNode(_2a1);
}
};
dojo.provide("dojo.svg");
dojo.mixin(dojo.svg,dojo.dom);
dojo.svg.graphics=dojo.svg.g=new function(d){
this.suspend=function(){
try{
d.documentElement.suspendRedraw(0);
}
catch(e){
}
};
this.resume=function(){
try{
d.documentElement.unsuspendRedraw(0);
}
catch(e){
}
};
this.force=function(){
try{
d.documentElement.forceRedraw();
}
catch(e){
}
};
}(document);
dojo.svg.animations=dojo.svg.anim=new function(d){
this.arePaused=function(){
try{
return d.documentElement.animationsPaused();
}
catch(e){
return false;
}
};
this.pause=function(){
try{
d.documentElement.pauseAnimations();
}
catch(e){
}
};
this.resume=function(){
try{
d.documentElement.unpauseAnimations();
}
catch(e){
}
};
}(document);
dojo.svg.toCamelCase=function(_2a4){
var arr=_2a4.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.svg.toSelectorCase=function(_2a8){
return _2a8.replace(/([A-Z])/g,"-$1").toLowerCase();
};
dojo.svg.getStyle=function(node,_2aa){
return document.defaultView.getComputedStyle(node,_2aa);
};
dojo.svg.getNumericStyle=function(node,_2ac){
return parseFloat(dojo.svg.getStyle(node,_2ac));
};
dojo.svg.getOpacity=function(node){
return Math.min(1,dojo.svg.getNumericStyle(node,"fill-opacity"));
};
dojo.svg.setOpacity=function(node,_2af){
node.setAttributeNS(this.xmlns.svg,"fill-opacity",_2af);
node.setAttributeNS(this.xmlns.svg,"stroke-opacity",_2af);
};
dojo.svg.clearOpacity=function(node){
node.setAttributeNS(this.xmlns.svg,"fill-opacity","1.0");
node.setAttributeNS(this.xmlns.svg,"stroke-opacity","1.0");
};
dojo.svg.getCoords=function(node){
if(node.getBBox){
var box=node.getBBox();
return {x:box.x,y:box.y};
}
return null;
};
dojo.svg.setCoords=function(node,_2b4){
var p=dojo.svg.getCoords();
if(!p){
return;
}
var dx=p.x-_2b4.x;
var dy=p.y-_2b4.y;
dojo.svg.translate(node,dx,dy);
};
dojo.svg.getDimensions=function(node){
if(node.getBBox){
var box=node.getBBox();
return {width:box.width,height:box.height};
}
return null;
};
dojo.svg.setDimensions=function(node,dim){
if(node.width){
node.width.baseVal.value=dim.width;
node.height.baseVal.value=dim.height;
}else{
if(node.r){
node.r.baseVal.value=Math.min(dim.width,dim.height)/2;
}else{
if(node.rx){
node.rx.baseVal.value=dim.width/2;
node.ry.baseVal.value=dim.height/2;
}
}
}
};
dojo.svg.translate=function(node,dx,dy){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setTranslate(dx,dy);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.scale=function(node,_2c1,_2c2){
if(!_2c2){
var _2c2=_2c1;
}
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setScale(_2c1,_2c2);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.rotate=function(node,ang,cx,cy){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
if(cx==null){
t.setMatrix(t.matrix.rotate(ang));
}else{
t.setRotate(ang,cx,cy);
}
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.skew=function(node,ang,axis){
var dir=axis||"x";
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
if(dir!="x"){
t.setSkewY(ang);
}else{
t.setSkewX(ang);
}
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.flip=function(node,axis){
var dir=axis||"x";
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix((dir!="x")?t.matrix.flipY():t.matrix.flipX());
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.invert=function(node){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix(t.matrix.inverse());
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.applyMatrix=function(node,a,b,c,d,e,f){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var m;
if(b){
var m=node.ownerSVGElement.createSVGMatrix();
m.a=a;
m.b=b;
m.c=c;
m.d=d;
m.e=e;
m.f=f;
}else{
m=a;
}
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix(m);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.group=function(_2dd){
var p=_2dd.item(0).parentNode;
var g=document.createElementNS(this.xmlns.svg,"g");
for(var i=0;i<_2dd.length;i++){
g.appendChild(_2dd.item(i));
}
p.appendChild(g);
return g;
};
dojo.svg.ungroup=function(g){
var p=g.parentNode;
while(g.childNodes.length>0){
p.appendChild(g.childNodes.item(0));
}
p.removeChild(g);
};
dojo.svg.getGroup=function(node){
var a=this.getAncestors(node);
for(var i=0;i<a.length;i++){
if(a[i].nodeType==this.ELEMENT_NODE&&a[i].nodeName.toLowerCase()=="g"){
return a[i];
}
}
return null;
};
dojo.svg.bringToFront=function(node){
var n=this.getGroup(node)||node;
n.ownerSVGElement.appendChild(n);
};
dojo.svg.sendToBack=function(node){
var n=this.getGroup(node)||node;
n.ownerSVGElement.insertBefore(n,n.ownerSVGElement.firstChild);
};
dojo.svg.bringForward=function(node){
var n=this.getGroup(node)||node;
if(this.getLastChildElement(n.parentNode)!=n){
this.insertAfter(n,this.getNextSiblingElement(n),true);
}
};
dojo.svg.sendBackward=function(node){
var n=this.getGroup(node)||node;
if(this.getFirstChildElement(n.parentNode)!=n){
this.insertBefore(n,this.getPreviousSiblingElement(n),true);
}
};
dojo.svg.createNodesFromText=function(txt,wrap){
var _2f0=(new DOMParser()).parseFromString(txt,"text/xml").normalize();
if(wrap){
return [_2f0.firstChild.cloneNode(true)];
}
var _2f1=[];
for(var x=0;x<_2f0.childNodes.length;x++){
_2f1.push(_2f0.childNodes.item(x).cloneNode(true));
}
return _2f1;
};
dojo.provide("dojo.charting.Axis");
dojo.charting.Axis=function(_2f3,_2f4,_2f5){
var id="dojo-charting-axis-"+dojo.charting.Axis.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.scale=_2f4||"linear";
this.label=_2f3||"";
this.showLabel=true;
this.showLabels=true;
this.showLines=false;
this.showTicks=false;
this.range={upper:0,lower:0};
this.origin="min";
this.labels=_2f5||[];
this._labels=[];
this.nodes={main:null,axis:null,label:null,labels:null,lines:null,ticks:null};
};
dojo.charting.Axis.count=0;
dojo.extend(dojo.charting.Axis,{getCoord:function(val,_2f9,plot){
val=parseFloat(val,10);
var area=_2f9.getArea();
if(plot.axisX==this){
var _2fc=0-this.range.lower;
var min=this.range.lower+_2fc;
var max=this.range.upper+_2fc;
val+=_2fc;
return (val*((area.right-area.left)/max))+area.left;
}else{
var max=this.range.upper;
var min=this.range.lower;
var _2fc=0;
if(min<0){
_2fc+=Math.abs(min);
}
max+=_2fc;
min+=_2fc;
val+=_2fc;
var pmin=area.bottom;
var pmax=area.top;
return (((pmin-pmax)/(max-min))*(max-val))+pmax;
}
},initializeOrigin:function(_301,_302){
if(isNaN(this.origin)){
if(this.origin.toLowerCase()=="max"){
this.origin=_301.range[(_302=="y")?"upper":"lower"];
}else{
if(this.origin.toLowerCase()=="min"){
this.origin=_301.range[(_302=="y")?"lower":"upper"];
}else{
this.origin=0;
}
}
}
},initializeLabels:function(){
if(this.labels.length==0){
this.showLabels=false;
this.showLines=false;
this.showTicks=false;
}else{
if(this.labels[0].label&&this.labels[0].value!=null){
for(var i=0;i<this.labels.length;i++){
this._labels.push(this.labels[i]);
}
}else{
if(!isNaN(this.labels[0])){
for(var i=0;i<this.labels.length;i++){
this._labels.push({label:this.labels[i],value:this.labels[i]});
}
}else{
var a=[];
for(var i=0;i<this.labels.length;i++){
a.push(this.labels[i]);
}
var s=a.shift();
this._labels.push({label:s,value:this.range.lower});
if(a.length>0){
var s=a.pop();
this._labels.push({label:s,value:this.range.upper});
}
if(a.length>0){
var _306=this.range.upper-this.range.lower;
var step=_306/(this.labels.length-1);
for(var i=1;i<=a.length;i++){
this._labels.push({label:a[i-1],value:this.range.lower+(step*i)});
}
}
}
}
}
},initialize:function(_308,plot,_30a,_30b){
this.destroy();
this.initializeOrigin(_30a,_30b);
this.initializeLabels();
var node=this.render(_308,plot,_30a,_30b);
return node;
},destroy:function(){
for(var p in this.nodes){
while(this.nodes[p]&&this.nodes[p].childNodes.length>0){
this.nodes[p].removeChild(this.nodes[p].childNodes[0]);
}
if(this.nodes[p]&&this.nodes[p].parentNode){
this.nodes[p].parentNode.removeChild(this.nodes[p]);
}
this.nodes[p]=null;
}
}});
dojo.provide("dojo.charting.svg.Axis");
if(dojo.render.svg.capable){
dojo.extend(dojo.charting.Axis,{renderLines:function(_30e,plot,_310){
if(this.nodes.lines){
while(this.nodes.lines.childNodes.length>0){
this.nodes.lines.removeChild(this.nodes.lines.childNodes[0]);
}
if(this.nodes.lines.parentNode){
this.nodes.lines.parentNode.removeChild(this.nodes.lines);
this.nodes.lines=null;
}
}
var area=_30e.getArea();
var g=this.nodes.lines=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-lines");
for(var i=0;i<this._labels.length;i++){
if(this._labels[i].value==this.origin){
continue;
}
var v=this.getCoord(this._labels[i].value,_30e,plot);
var l=document.createElementNS(dojo.svg.xmlns.svg,"line");
l.setAttribute("style","stroke:#999;stroke-width:1px;stroke-dasharray:1,4;");
if(_310=="x"){
l.setAttribute("y1",area.top);
l.setAttribute("y2",area.bottom);
l.setAttribute("x1",v);
l.setAttribute("x2",v);
}else{
if(_310=="y"){
l.setAttribute("y1",v);
l.setAttribute("y2",v);
l.setAttribute("x1",area.left);
l.setAttribute("x2",area.right);
}
}
g.appendChild(l);
}
return g;
},renderTicks:function(_316,plot,_318,_319){
if(this.nodes.ticks){
while(this.nodes.ticks.childNodes.length>0){
this.nodes.ticks.removeChild(this.nodes.ticks.childNodes[0]);
}
if(this.nodes.ticks.parentNode){
this.nodes.ticks.parentNode.removeChild(this.nodes.ticks);
this.nodes.ticks=null;
}
}
var g=this.nodes.ticks=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-ticks");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_316,plot);
var l=document.createElementNS(dojo.svg.xmlns.svg,"line");
l.setAttribute("style","stroke:#000;stroke-width:1pt;");
if(_318=="x"){
l.setAttribute("y1",_319);
l.setAttribute("y2",_319+3);
l.setAttribute("x1",v);
l.setAttribute("x2",v);
}else{
if(_318=="y"){
l.setAttribute("y1",v);
l.setAttribute("y2",v);
l.setAttribute("x1",_319-2);
l.setAttribute("x2",_319+2);
}
}
g.appendChild(l);
}
return g;
},renderLabels:function(_31e,plot,_320,_321,_322,_323){
function createLabel(_324,x,y,_327,_328){
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",(_320=="x"?y:y+2));
text.setAttribute("style","text-anchor:"+_328+";font-family:sans-serif;font-size:"+_327+"px;fill:#000;");
text.appendChild(document.createTextNode(_324));
return text;
}
if(this.nodes.labels){
while(this.nodes.labels.childNodes.length>0){
this.nodes.labels.removeChild(this.nodes.labels.childNodes[0]);
}
if(this.nodes.labels.parentNode){
this.nodes.labels.parentNode.removeChild(this.nodes.labels);
this.nodes.labels=null;
}
}
var g=this.nodes.labels=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-labels");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_31e,plot);
if(_320=="x"){
g.appendChild(createLabel(this._labels[i].label,v,_321,_322,_323));
}else{
if(_320=="y"){
g.appendChild(createLabel(this._labels[i].label,_321,v,_322,_323));
}
}
}
return g;
},render:function(_32d,plot,_32f,_330){
var area=_32d.getArea();
var _332=1;
var _333="stroke:#000;stroke-width:"+_332+"px;";
var _334=10;
var _335=_32f.getCoord(this.origin,_32d,plot);
this.nodes.main=document.createElementNS(dojo.svg.xmlns.svg,"g");
var g=this.nodes.main;
g.setAttribute("id",this.getId());
var line=this.nodes.axis=document.createElementNS(dojo.svg.xmlns.svg,"line");
if(_330=="x"){
line.setAttribute("y1",_335);
line.setAttribute("y2",_335);
line.setAttribute("x1",area.left-_332);
line.setAttribute("x2",area.right+_332);
line.setAttribute("style",_333);
var y=_335+_334+2;
if(this.showLines){
g.appendChild(this.renderLines(_32d,plot,_330,y));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_32d,plot,_330,_335));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_32d,plot,_330,y,_334,"middle"));
}
if(this.showLabel&&this.label){
var x=_32d.size.width/2;
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",(_335+(_334*2)+(_334/2)));
text.setAttribute("style","text-anchor:middle;font-family:sans-serif;font-weight:bold;font-size:"+(_334+2)+"px;fill:#000;");
text.appendChild(document.createTextNode(this.label));
g.appendChild(text);
}
}else{
line.setAttribute("x1",_335);
line.setAttribute("x2",_335);
line.setAttribute("y1",area.top);
line.setAttribute("y2",area.bottom);
line.setAttribute("style",_333);
var _33b=this.origin==_32f.range.upper;
var x=_335+(_33b?4:-4);
var _33c=_33b?"start":"end";
if(this.showLines){
g.appendChild(this.renderLines(_32d,plot,_330,x));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_32d,plot,_330,_335));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_32d,plot,_330,x,_334,_33c));
}
if(this.showLabel&&this.label){
var x=_33b?(_335+(_334*2)+(_334/2)):(_335-(_334*4));
var y=_32d.size.height/2;
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",y);
text.setAttribute("transform","rotate(90, "+x+", "+y+")");
text.setAttribute("style","text-anchor:middle;font-family:sans-serif;font-weight:bold;font-size:"+(_334+2)+"px;fill:#000;");
text.appendChild(document.createTextNode(this.label));
g.appendChild(text);
}
}
g.appendChild(line);
return g;
}});
}
dojo.provide("dojo.charting.vml.Axis");
if(dojo.render.vml.capable){
dojo.extend(dojo.charting.Axis,{renderLines:function(_33d,plot,_33f){
if(this.nodes.lines){
while(this.nodes.lines.childNodes.length>0){
this.nodes.lines.removeChild(this.nodes.lines.childNodes[0]);
}
if(this.nodes.lines.parentNode){
this.nodes.lines.parentNode.removeChild(this.nodes.lines);
this.nodes.lines=null;
}
}
var area=_33d.getArea();
var g=this.nodes.lines=document.createElement("div");
g.setAttribute("id",this.getId()+"-lines");
for(var i=0;i<this._labels.length;i++){
if(this._labels[i].value==this.origin){
continue;
}
var v=this.getCoord(this._labels[i].value,_33d,plot);
var l=document.createElement("v:line");
var str=document.createElement("v:stroke");
str.dashstyle="dot";
l.appendChild(str);
l.setAttribute("strokecolor","#666");
l.setAttribute("strokeweight","1px");
var s=l.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_33f=="x"){
l.setAttribute("from",v+"px,"+area.top+"px");
l.setAttribute("to",v+"px,"+area.bottom+"px");
}else{
if(_33f=="y"){
l.setAttribute("from",area.left+"px,"+v+"px");
l.setAttribute("to",area.right+"px,"+v+"px");
}
}
g.appendChild(l);
}
return g;
},renderTicks:function(_347,plot,_349,_34a){
if(this.nodes.ticks){
while(this.nodes.ticks.childNodes.length>0){
this.nodes.ticks.removeChild(this.nodes.ticks.childNodes[0]);
}
if(this.nodes.ticks.parentNode){
this.nodes.ticks.parentNode.removeChild(this.nodes.ticks);
this.nodes.ticks=null;
}
}
var g=this.nodes.ticks=document.createElement("div");
g.setAttribute("id",this.getId()+"-ticks");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_347,plot);
var l=document.createElement("v:line");
l.setAttribute("strokecolor","#000");
l.setAttribute("strokeweight","1px");
var s=l.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_349=="x"){
l.setAttribute("from",v+"px,"+_34a+"px");
l.setAttribute("to",v+"px,"+(_34a+3)+"px");
}else{
if(_349=="y"){
l.setAttribute("from",(_34a-2)+"px,"+v+"px");
l.setAttribute("to",(_34a+2)+"px,"+v+"px");
}
}
g.appendChild(l);
}
return g;
},renderLabels:function(_350,plot,_352,_353,_354,_355){
function createLabel(_356,x,y,_359,_35a){
var text=document.createElement("div");
var s=text.style;
text.innerHTML=_356;
s.fontSize=_359+"px";
s.fontFamily="sans-serif";
s.position="absolute";
s.top=y+"px";
if(_35a=="center"){
s.left=x+"px";
s.textAlign="center";
}else{
if(_35a=="left"){
s.left=x+"px";
s.textAlign="left";
}else{
if(_35a=="right"){
s.right=x+"px";
s.textAlign="right";
}
}
}
return text;
}
if(this.nodes.labels){
while(this.nodes.labels.childNodes.length>0){
this.nodes.labels.removeChild(this.nodes.labels.childNodes[0]);
}
if(this.nodes.labels.parentNode){
this.nodes.labels.parentNode.removeChild(this.nodes.labels);
this.nodes.labels=null;
}
}
var g=this.nodes.labels=document.createElement("div");
g.setAttribute("id",this.getId()+"-labels");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_350,plot);
if(_352=="x"){
var node=createLabel(this._labels[i].label,v,_353,_354,_355);
document.body.appendChild(node);
node.style.left=v-(node.offsetWidth/2)+"px";
g.appendChild(node);
}else{
if(_352=="y"){
var node=createLabel(this._labels[i].label,_353,v,_354,_355);
document.body.appendChild(node);
node.style.top=v-(node.offsetHeight/2)+"px";
g.appendChild(node);
}
}
}
return g;
},render:function(_361,plot,_363,_364){
var area=_361.getArea();
var _366=1;
var _367="stroke:#000;stroke-width:"+_366+"px;";
var _368=10;
var _369=_363.getCoord(this.origin,_361,plot);
var g=this.nodes.main=document.createElement("div");
g.setAttribute("id",this.getId());
var line=this.nodes.axis=document.createElement("v:line");
line.setAttribute("strokecolor","#000");
line.setAttribute("strokeweight",_366+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_364=="x"){
line.setAttribute("from",area.left+"px,"+_369+"px");
line.setAttribute("to",area.right+"px,"+_369+"px");
var y=_369+Math.floor(_368/2);
if(this.showLines){
g.appendChild(this.renderLines(_361,plot,_364,y));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_361,plot,_364,_369));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_361,plot,_364,y,_368,"center"));
}
if(this.showLabel&&this.label){
var x=_361.size.width/2;
var y=_369+Math.round(_368*1.5);
var text=document.createElement("div");
var s=text.style;
text.innerHTML=this.label;
s.fontSize=(_368+2)+"px";
s.fontFamily="sans-serif";
s.fontWeight="bold";
s.position="absolute";
s.top=y+"px";
s.left=x+"px";
s.textAlign="center";
document.body.appendChild(text);
text.style.left=x-(text.offsetWidth/2)+"px";
g.appendChild(text);
}
}else{
line.setAttribute("from",_369+"px,"+area.top+"px");
line.setAttribute("to",_369+"px,"+area.bottom+"px");
var _370=this.origin==_363.range.upper;
var x=_369+4;
var _371="left";
if(!_370){
x=area.right-_369+_368+4;
_371="right";
if(_369==area.left){
x+=(_368*2)-(_368/2);
}
}
if(this.showLines){
g.appendChild(this.renderLines(_361,plot,_364,x));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_361,plot,_364,_369));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_361,plot,_364,x,_368,_371));
}
if(this.showLabel&&this.label){
x+=(_368*2)-2;
var y=_361.size.height/2;
var text=document.createElement("div");
var s=text.style;
text.innerHTML=this.label;
s.fontSize=(_368+2)+"px";
s.fontFamily="sans-serif";
s.fontWeight="bold";
s.position="absolute";
s.height=_361.size.height+"px";
s.writingMode="tb-rl";
s.textAlign="center";
s[_371]=x+"px";
document.body.appendChild(text);
s.top=y-(text.offsetHeight/2)+"px";
g.appendChild(text);
}
}
g.appendChild(line);
return g;
}});
}
dojo.provide("dojo.charting.Plotters");
dojo.provide("dojo.charting.svg.Plotters");
if(dojo.render.svg.capable){
dojo.require("dojo.svg");
dojo.mixin(dojo.charting.Plotters,{Bar:function(_372,plot,_374,_375){
var area=_372.getArea();
var _377=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_374);
data.push(tmp);
}
var _37c=8;
var _37d=data[0].length;
var _37e=((area.right-area.left)-(_37c*(_37d-1)))/_37d;
var _37f=_37e/n;
var _380=plot.axisY.getCoord(plot.axisX.origin,_372,plot);
for(var i=0;i<_37d;i++){
var _381=area.left+(_37e*i)+(_37c*i);
for(var j=0;j<n;j++){
var _383=data[j][i].y;
var yA=_380;
var x=_381+(_37f*j);
var y=plot.axisY.getCoord(_383,_372,plot);
var h=Math.abs(yA-y);
if(_383<plot.axisX.origin){
yA=y;
y=_380;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",_37f);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_375){
_375(bar,data[j][i].src);
}
_377.appendChild(bar);
}
}
return _377;
},HorizontalBar:function(_389,plot,_38b,_38c){
var area=_389.getArea();
var _38e=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_38b);
data.push(tmp);
}
var _393=6;
var _394=data[0].length;
var h=((area.bottom-area.top)-(_393*(_394-1)))/_394;
var barH=h/n;
var _397=plot.axisX.getCoord(0,_389,plot);
for(var i=0;i<_394;i++){
var _398=area.top+(h*i)+(_393*i);
for(var j=0;j<n;j++){
var _39a=data[j][i].y;
var y=_398+(barH*j);
var xA=_397;
var x=plot.axisX.getCoord(_39a,_389,plot);
var w=Math.abs(x-xA);
if(_39a>0){
x=_397;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",xA);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",barH);
bar.setAttribute("fill-opacity","0.6");
if(_38c){
_38c(bar,data[j][i].src);
}
_38e.appendChild(bar);
}
}
return _38e;
},Gantt:function(_3a0,plot,_3a2,_3a3){
var area=_3a0.getArea();
var _3a5=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3a2);
data.push(tmp);
}
var _3aa=2;
var _3ab=data[0].length;
var h=((area.bottom-area.top)-(_3aa*(_3ab-1)))/_3ab;
var barH=h/n;
for(var i=0;i<_3ab;i++){
var _3ae=area.top+(h*i)+(_3aa*i);
for(var j=0;j<n;j++){
var high=data[j][i].high;
var low=data[j][i].low;
if(low>high){
var t=high;
high=low;
low=t;
}
var x=plot.axisX.getCoord(low,_3a0,plot);
var w=plot.axisX.getCoord(high,_3a0,plot)-x;
var y=_3ae+(barH*j);
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",barH);
bar.setAttribute("fill-opacity","0.6");
if(_3a3){
_3a3(bar,data[j][i].src);
}
_3a5.appendChild(bar);
}
}
return _3a5;
},StackedArea:function(_3b7,plot,_3b9,_3ba){
var area=_3b7.getArea();
var _3bc=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
var _3bf=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3b9);
for(var j=0;j<tmp.length;j++){
if(i==0){
_3bf.push(tmp[j].y);
}else{
_3bf[j]+=tmp[j].y;
}
tmp[j].y=_3bf[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
path.setAttribute("fill",data[i][0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[i][0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _3c6=data[i];
var x=plot.axisX.getCoord(_3c6[j].x,_3b7,plot);
var y=plot.axisY.getCoord(_3c6[j].y,_3b7,plot);
if(j==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",_3c6[j].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
_3bc.appendChild(c);
if(_3ba){
_3ba(c,data[i].src);
}
}
if(i==0){
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_3b7,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0][0].x,_3b7,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_3b7,plot));
cmd.push("Z");
}else{
var _3c6=data[i-1];
cmd.push("L");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_3c6[_3c6.length-1].y,_3b7,plot)));
for(var j=_3c6.length-2;j>=0;j--){
var x=plot.axisX.getCoord(_3c6[j].x,_3b7,plot);
var y=plot.axisY.getCoord(_3c6[j].y,_3b7,plot);
cmd.push("L");
cmd.push(x+","+y);
}
}
path.setAttribute("d",cmd.join(" ")+" Z");
_3bc.appendChild(path);
}
return _3bc;
},StackedCurvedArea:function(_3ca,plot,_3cc,_3cd){
var _3ce=3;
var area=_3ca.getArea();
var _3d0=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
var _3d3=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3cc);
for(var j=0;j<tmp.length;j++){
if(i==0){
_3d3.push(tmp[j].y);
}else{
_3d3[j]+=tmp[j].y;
}
tmp[j].y=_3d3[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
path.setAttribute("fill",data[i][0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[i][0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _3da=data[i];
var x=plot.axisX.getCoord(_3da[j].x,_3ca,plot);
var y=plot.axisY.getCoord(_3da[j].y,_3ca,plot);
var dx=area.left+1;
var dy=area.bottom;
if(j>0){
dx=x-plot.axisX.getCoord(_3da[j-1].x,_3ca,plot);
dy=plot.axisY.getCoord(_3da[j-1].y,_3ca,plot);
}
if(j==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_3ce-1)*(dx/_3ce);
cmd.push(cx+","+dy);
cx=x-(dx/_3ce);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",_3da[j].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
_3d0.appendChild(c);
if(_3cd){
_3cd(c,data[i].src);
}
}
if(i==0){
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_3ca,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0][0].x,_3ca,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_3ca,plot));
cmd.push("Z");
}else{
var _3da=data[i-1];
cmd.push("L");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_3da[_3da.length-1].y,_3ca,plot)));
for(var j=_3da.length-2;j>=0;j--){
var x=plot.axisX.getCoord(_3da[j].x,_3ca,plot);
var y=plot.axisY.getCoord(_3da[j].y,_3ca,plot);
var dx=x-plot.axisX.getCoord(_3da[j+1].x,_3ca,plot);
var dy=plot.axisY.getCoord(_3da[j+1].y,_3ca,plot);
cmd.push("C");
var cx=x-(_3ce-1)*(dx/_3ce);
cmd.push(cx+","+dy);
cx=x-(dx/_3ce);
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
}
path.setAttribute("d",cmd.join(" ")+" Z");
_3d0.appendChild(path);
}
return _3d0;
},DataBar:function(data,_3e2,plot,_3e4){
var area=_3e2.getArea();
var _3e6=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var w=(area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower);
var _3e9=plot.axisY.getCoord(plot.axisX.origin,_3e2,plot);
for(var i=0;i<n;i++){
var _3eb=data[i].y;
var yA=_3e9;
var x=plot.axisX.getCoord(data[i].x,_3e2,plot)-(w/2);
var y=plot.axisY.getCoord(_3eb,_3e2,plot);
var h=Math.abs(yA-y);
if(_3eb<plot.axisX.origin){
yA=y;
y=_3e9;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_3e4){
_3e4(bar,data[i].src);
}
_3e6.appendChild(bar);
}
return _3e6;
},Line:function(data,_3f2,plot,_3f4){
var area=_3f2.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill","none");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","2");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_3f2,plot);
var y=plot.axisY.getCoord(data[i].y,_3f2,plot);
if(i==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_3f4){
_3f4(c,data[i].src);
}
}
path.setAttribute("d",cmd.join(" "));
return line;
},CurvedLine:function(data,_3fe,plot,_400){
var _401=3;
var area=_3fe.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill","none");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","2");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_3fe,plot);
var y=plot.axisY.getCoord(data[i].y,_3fe,plot);
var dx=area.left+1;
var dy=area.bottom;
if(i>0){
dx=x-plot.axisX.getCoord(data[i-1].x,_3fe,plot);
dy=plot.axisY.getCoord(data[i-1].y,_3fe,plot);
}
if(i==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_401-1)*(dx/_401);
cmd.push(cx+","+dy);
cx=x-(dx/_401);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_400){
_400(c,data[i].src);
}
}
path.setAttribute("d",cmd.join(" "));
return line;
},Area:function(data,_40e,plot,_410){
var area=_40e.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill",data[0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_40e,plot);
var y=plot.axisY.getCoord(data[i].y,_40e,plot);
if(i==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_410){
_410(c,data[i].src);
}
}
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_40e,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0].x,_40e,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_40e,plot));
cmd.push("Z");
path.setAttribute("d",cmd.join(" "));
return line;
},CurvedArea:function(data,_41a,plot,_41c){
var _41d=3;
var area=_41a.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill",data[0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_41a,plot);
var y=plot.axisY.getCoord(data[i].y,_41a,plot);
var dx=area.left+1;
var dy=area.bottom;
if(i>0){
dx=x-plot.axisX.getCoord(data[i-1].x,_41a,plot);
dy=plot.axisY.getCoord(data[i-1].y,_41a,plot);
}
if(i==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_41d-1)*(dx/_41d);
cmd.push(cx+","+dy);
cx=x-(dx/_41d);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_41c){
_41c(c,data[i].src);
}
}
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_41a,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0].x,_41a,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_41a,plot));
cmd.push("Z");
path.setAttribute("d",cmd.join(" "));
return line;
},HighLow:function(data,_42a,plot,_42c){
var area=_42a.getArea();
var _42e=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var x=plot.axisX.getCoord(data[i].x,_42a,plot)-(w/2);
var y=plot.axisY.getCoord(high,_42a,plot);
var h=plot.axisY.getCoord(low,_42a,plot)-y;
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_42c){
_42c(bar,data[i].src);
}
_42e.appendChild(bar);
}
return _42e;
},HighLowClose:function(data,_43b,plot,_43d){
var area=_43b.getArea();
var _43f=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_43b,plot)-(w/2);
var y=plot.axisY.getCoord(high,_43b,plot);
var h=plot.axisY.getCoord(low,_43b,plot)-y;
var _44b=plot.axisY.getCoord(c,_43b,plot);
var g=document.createElementNS(dojo.svg.xmlns.svg,"g");
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
g.appendChild(bar);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x);
line.setAttribute("x2",x+w+(part*2));
line.setAttribute("y1",_44b);
line.setAttribute("y2",_44b);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
if(_43d){
_43d(g,data[i].src);
}
_43f.appendChild(g);
}
return _43f;
},HighLowOpenClose:function(data,_450,plot,_452){
var area=_450.getArea();
var _454=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var o=data[i].open;
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_450,plot)-(w/2);
var y=plot.axisY.getCoord(high,_450,plot);
var h=plot.axisY.getCoord(low,_450,plot)-y;
var open=plot.axisY.getCoord(o,_450,plot);
var _462=plot.axisY.getCoord(c,_450,plot);
var g=document.createElementNS(dojo.svg.xmlns.svg,"g");
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
g.appendChild(bar);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x-(part*2));
line.setAttribute("x2",x+w);
line.setAttribute("y1",open);
line.setAttribute("y2",open);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x);
line.setAttribute("x2",x+w+(part*2));
line.setAttribute("y1",_462);
line.setAttribute("y2",_462);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
if(_452){
_452(g,data[i].src);
}
_454.appendChild(g);
}
return _454;
},Scatter:function(data,_467,plot,_469){
var r=7;
var _46b=document.createElementNS(dojo.svg.xmlns.svg,"g");
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_467,plot);
var y=plot.axisY.getCoord(data[i].y,_467,plot);
var _46f=document.createElementNS(dojo.svg.xmlns.svg,"path");
_46f.setAttribute("fill",data[i].series.color);
_46f.setAttribute("stroke-width","0");
_46f.setAttribute("d","M "+x+","+(y-r)+" "+"Q "+x+","+y+" "+(x+r)+","+y+" "+"Q "+x+","+y+" "+x+","+(y+r)+" "+"Q "+x+","+y+" "+(x-r)+","+y+" "+"Q "+x+","+y+" "+x+","+(y-r)+" "+"Z");
if(_469){
_469(_46f,data[i].src);
}
_46b.appendChild(_46f);
}
return _46b;
},Bubble:function(data,_471,plot,_473){
var _474=document.createElementNS(dojo.svg.xmlns.svg,"g");
var _475=1;
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_471,plot);
var y=plot.axisY.getCoord(data[i].y,_471,plot);
if(i==0){
var raw=data[i].size;
var dy=plot.axisY.getCoord(data[i].y+raw,_471,plot)-y;
_475=dy/raw;
}
if(_475<1){
_475=1;
}
var _47b=document.createElementNS(dojo.svg.xmlns.svg,"circle");
_47b.setAttribute("fill",data[i].series.color);
_47b.setAttribute("fill-opacity","0.8");
_47b.setAttribute("stroke",data[i].series.color);
_47b.setAttribute("stroke-width","1");
_47b.setAttribute("cx",x);
_47b.setAttribute("cy",y);
_47b.setAttribute("r",(data[i].size/2)*_475);
if(_473){
_473(_47b,data[i].src);
}
_474.appendChild(_47b);
}
return _474;
}});
dojo.charting.Plotters["Default"]=dojo.charting.Plotters.Line;
}
dojo.provide("dojo.charting.vml.Plotters");
if(dojo.render.vml.capable){
dojo.mixin(dojo.charting.Plotters,{_group:function(_47c){
var _47d=document.createElement("div");
_47d.style.position="absolute";
_47d.style.top="0px";
_47d.style.left="0px";
_47d.style.width=_47c.size.width+"px";
_47d.style.height=_47c.size.height+"px";
return _47d;
},Bar:function(_47e,plot,_480,_481){
var area=_47e.getArea();
var _483=dojo.charting.Plotters._group(_47e);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_480);
data.push(tmp);
}
var _488=8;
var _489=data[0].length;
var _48a=((area.right-area.left)-(_488*(_489-1)))/_489;
var _48b=Math.round(_48a/n);
var _48c=plot.axisY.getCoord(plot.axisX.origin,_47e,plot);
for(var i=0;i<_489;i++){
var _48d=area.left+(_48a*i)+(_488*i);
for(var j=0;j<n;j++){
var _48f=data[j][i].y;
var yA=_48c;
var x=_48d+(_48b*j);
var y=plot.axisY.getCoord(_48f,_47e,plot);
var h=Math.abs(yA-y);
if(_48f<plot.axisX.origin){
yA=y;
y=_48c;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=_48b+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_481){
_481(bar,data[j][i].src);
}
_483.appendChild(bar);
}
}
return _483;
},HorizontalBar:function(_496,plot,_498,_499){
var area=_496.getArea();
var _49b=dojo.charting.Plotters._group(_496);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_498);
data.push(tmp);
}
var _4a0=6;
var _4a1=data[0].length;
var h=((area.bottom-area.top)-(_4a0*(_4a1-1)))/_4a1;
var barH=h/n;
var _4a4=plot.axisX.getCoord(0,_496,plot);
for(var i=0;i<_4a1;i++){
var _4a5=area.top+(h*i)+(_4a0*i);
for(var j=0;j<n;j++){
var _4a7=data[j][i].y;
var y=_4a5+(barH*j);
var xA=_4a4;
var x=plot.axisX.getCoord(_4a7,_496,plot);
var w=Math.abs(x-xA);
if(_4a7>0){
x=_4a4;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=xA+"px";
bar.style.width=w+"px";
bar.style.height=barH+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_499){
_499(bar,data[j][i].src);
}
_49b.appendChild(bar);
}
}
var _4a0=4;
var n=plot.series.length;
var h=((area.bottom-area.top)-(_4a0*(n-1)))/n;
var _4a4=plot.axisX.getCoord(0,_496,plot);
for(var i=0;i<n;i++){
var _4ae=plot.series[i];
var data=_4ae.data.evaluate(_498);
var y=area.top+(h*i)+(_4a0*i);
var _4a7=data[data.length-1].y;
var xA=_4a4;
var x=plot.axisX.getCoord(_4a7,_496,plot);
var w=Math.abs(xA-x);
if(_4a7>0){
xA=x;
x=_4a4;
}
}
return _49b;
},Gantt:function(_4af,plot,_4b1,_4b2){
var area=_4af.getArea();
var _4b4=dojo.charting.Plotters._group(_4af);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4b1);
data.push(tmp);
}
var _4b9=2;
var _4ba=data[0].length;
var h=((area.bottom-area.top)-(_4b9*(_4ba-1)))/_4ba;
var barH=h/n;
for(var i=0;i<_4ba;i++){
var _4bd=area.top+(h*i)+(_4b9*i);
for(var j=0;j<n;j++){
var high=data[j][i].high;
var low=data[j][i].low;
if(low>high){
var t=high;
high=low;
low=t;
}
var x=plot.axisX.getCoord(low,_4af,plot);
var w=plot.axisX.getCoord(high,_4af,plot)-x;
var y=_4bd+(barH*j);
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=barH+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_4b2){
_4b2(bar,data[j][i].src);
}
_4b4.appendChild(bar);
}
}
return _4b4;
},StackedArea:function(_4c7,plot,_4c9,_4ca){
var area=_4c7.getArea();
var _4cc=dojo.charting.Plotters._group(_4c7);
var n=plot.series.length;
var data=[];
var _4cf=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4c9);
for(var j=0;j<tmp.length;j++){
if(i==0){
_4cf.push(tmp[j].y);
}else{
_4cf[j]+=tmp[j].y;
}
tmp[j].y=_4cf[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[i][0].series.color);
path.setAttribute("fillcolor",data[i][0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _4d4=document.createElement("v:stroke");
_4d4.setAttribute("opacity","0.8");
path.appendChild(_4d4);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _4d8=data[i];
var x=Math.round(plot.axisX.getCoord(_4d8[j].x,_4c7,plot));
var y=Math.round(plot.axisY.getCoord(_4d8[j].y,_4c7,plot));
if(j==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",_4d8[j].series.color);
c.setAttribute("fillcolor",_4d8[j].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_4cc.appendChild(c);
if(_4ca){
_4ca(c,data[j].src);
}
}
if(i==0){
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4c7,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0][0].x,_4c7,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4c7,plot)));
}else{
var _4d8=data[i-1];
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_4d8[_4d8.length-1].y,_4c7,plot)));
for(var j=_4d8.length-2;j>=0;j--){
var x=Math.round(plot.axisX.getCoord(_4d8[j].x,_4c7,plot));
var y=Math.round(plot.axisY.getCoord(_4d8[j].y,_4c7,plot));
cmd.push("l");
cmd.push(x+","+y);
}
}
path.setAttribute("path",cmd.join(" ")+" x e");
_4cc.appendChild(path);
}
return _4cc;
},StackedCurvedArea:function(_4de,plot,_4e0,_4e1){
var _4e2=3;
var area=_4de.getArea();
var _4e4=dojo.charting.Plotters._group(_4de);
var n=plot.series.length;
var data=[];
var _4e7=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4e0);
for(var j=0;j<tmp.length;j++){
if(i==0){
_4e7.push(tmp[j].y);
}else{
_4e7[j]+=tmp[j].y;
}
tmp[j].y=_4e7[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[i][0].series.color);
path.setAttribute("fillcolor",data[i][0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _4ec=document.createElement("v:stroke");
_4ec.setAttribute("opacity","0.8");
path.appendChild(_4ec);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _4f0=data[i];
var x=Math.round(plot.axisX.getCoord(_4f0[j].x,_4de,plot));
var y=Math.round(plot.axisY.getCoord(_4f0[j].y,_4de,plot));
if(j==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _4f3=Math.round(plot.axisX.getCoord(_4f0[j-1].x,_4de,plot));
var _4f4=Math.round(plot.axisY.getCoord(_4f0[j-1].y,_4de,plot));
var dx=x-_4f3;
var dy=y-_4f4;
cmd.push("c");
var cx=Math.round((x-(_4e2-1)*(dx/_4e2)));
cmd.push(cx+","+_4f4);
cx=Math.round((x-(dx/_4e2)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",_4f0[j].series.color);
c.setAttribute("fillcolor",_4f0[j].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_4e4.appendChild(c);
if(_4e1){
_4e1(c,data[j].src);
}
}
if(i==0){
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4de,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0][0].x,_4de,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4de,plot)));
}else{
var _4f0=data[i-1];
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_4f0[_4f0.length-1].y,_4de,plot)));
for(var j=_4f0.length-2;j>=0;j--){
var x=Math.round(plot.axisX.getCoord(_4f0[j].x,_4de,plot));
var y=Math.round(plot.axisY.getCoord(_4f0[j].y,_4de,plot));
var _4f3=Math.round(plot.axisX.getCoord(_4f0[j+1].x,_4de,plot));
var _4f4=Math.round(plot.axisY.getCoord(_4f0[j+1].y,_4de,plot));
var dx=x-_4f3;
var dy=y-_4f4;
cmd.push("c");
var cx=Math.round((x-(_4e2-1)*(dx/_4e2)));
cmd.push(cx+","+_4f4);
cx=Math.round((x-(dx/_4e2)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
}
path.setAttribute("path",cmd.join(" ")+" x e");
_4e4.appendChild(path);
}
return _4e4;
},DataBar:function(data,_4fc,plot,_4fe){
var area=_4fc.getArea();
var _500=dojo.charting.Plotters._group(_4fc);
var n=data.length;
var w=(area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower);
var _503=plot.axisY.getCoord(plot.axisX.origin,_4fc,plot);
for(var i=0;i<n;i++){
var _505=data[i].y;
var yA=_503;
var x=plot.axisX.getCoord(data[i].x,_4fc,plot)-(w/2)+1;
var y=plot.axisY.getCoord(_505,_4fc,plot);
var h=Math.abs(yA-y);
if(_505<plot.axisX.origin){
yA=y;
y=_503;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_4fe){
_4fe(bar,data[i].src);
}
_500.appendChild(bar);
}
return _500;
},Line:function(data,_50d,plot,_50f){
var area=_50d.getArea();
var _511=dojo.charting.Plotters._group(_50d);
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","2px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor","none");
path.setAttribute("filled","false");
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _513=document.createElement("v:stroke");
_513.setAttribute("opacity","0.8");
path.appendChild(_513);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_50d,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_50d,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_511.appendChild(c);
if(_50f){
_50f(c,data[i].src);
}
}
path.setAttribute("path",cmd.join(" ")+" e");
_511.appendChild(path);
return _511;
},CurvedLine:function(data,_51d,plot,_51f){
var _520=3;
var area=_51d.getArea();
var _522=dojo.charting.Plotters._group(_51d);
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","2px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor","none");
path.setAttribute("filled","false");
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _524=document.createElement("v:stroke");
_524.setAttribute("opacity","0.8");
path.appendChild(_524);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_51d,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_51d,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _52a=Math.round(plot.axisX.getCoord(data[i-1].x,_51d,plot));
var _52b=Math.round(plot.axisY.getCoord(data[i-1].y,_51d,plot));
var dx=x-_52a;
var dy=y-_52b;
cmd.push("c");
var cx=Math.round((x-(_520-1)*(dx/_520)));
cmd.push(cx+","+_52b);
cx=Math.round((x-(dx/_520)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_522.appendChild(c);
if(_51f){
_51f(c,data[i].src);
}
}
path.setAttribute("path",cmd.join(" ")+" e");
_522.appendChild(path);
return _522;
},Area:function(data,_533,plot,_535){
var area=_533.getArea();
var _537=dojo.charting.Plotters._group(_533);
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor",data[0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _539=document.createElement("v:stroke");
_539.setAttribute("opacity","0.8");
path.appendChild(_539);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_533,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_533,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_537.appendChild(c);
if(_535){
_535(c,data[i].src);
}
}
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_533,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0].x,_533,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_533,plot)));
path.setAttribute("path",cmd.join(" ")+" x e");
_537.appendChild(path);
return _537;
},CurvedArea:function(data,_544,plot,_546){
var _547=3;
var area=_544.getArea();
var _549=dojo.charting.Plotters._group(_544);
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor",data[0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _54b=document.createElement("v:stroke");
_54b.setAttribute("opacity","0.8");
path.appendChild(_54b);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_544,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_544,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _552=Math.round(plot.axisX.getCoord(data[i-1].x,_544,plot));
var _553=Math.round(plot.axisY.getCoord(data[i-1].y,_544,plot));
var dx=x-_552;
var dy=y-_553;
cmd.push("c");
var cx=Math.round((x-(_547-1)*(dx/_547)));
cmd.push(cx+","+_553);
cx=Math.round((x-(dx/_547)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_549.appendChild(c);
if(_546){
_546(c,data[i].src);
}
}
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_544,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0].x,_544,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_544,plot)));
path.setAttribute("path",cmd.join(" ")+" x e");
_549.appendChild(path);
return _549;
},HighLow:function(data,_55b,plot,_55d){
var area=_55b.getArea();
var _55f=dojo.charting.Plotters._group(_55b);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var x=plot.axisX.getCoord(data[i].x,_55b,plot)-(w/2);
var y=plot.axisY.getCoord(high,_55b,plot);
var h=plot.axisY.getCoord(low,_55b,plot)-y;
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_55d){
_55d(bar,data[i].src);
}
_55f.appendChild(bar);
}
return _55f;
},HighLowClose:function(data,_56d,plot,_56f){
var area=_56d.getArea();
var _571=dojo.charting.Plotters._group(_56d);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_56d,plot)-(w/2);
var y=plot.axisY.getCoord(high,_56d,plot);
var h=plot.axisY.getCoord(low,_56d,plot)-y;
var _57d=plot.axisY.getCoord(c,_56d,plot);
var g=document.createElement("div");
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
g.appendChild(bar);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",x+"px,"+_57d+"px");
line.setAttribute("to",(x+w+(part*2)-2)+"px,"+_57d+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
if(_56f){
_56f(g,data[i].src);
}
_571.appendChild(g);
}
return _571;
},HighLowOpenClose:function(data,_585,plot,_587){
var area=_585.getArea();
var _589=dojo.charting.Plotters._group(_585);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var o=data[i].open;
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_585,plot)-(w/2);
var y=plot.axisY.getCoord(high,_585,plot);
var h=plot.axisY.getCoord(low,_585,plot)-y;
var open=plot.axisY.getCoord(o,_585,plot);
var _597=plot.axisY.getCoord(c,_585,plot);
var g=document.createElement("div");
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
g.appendChild(bar);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",(x-(part*2))+"px,"+open+"px");
line.setAttribute("to",(x+w-2)+"px,"+open+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",x+"px,"+_597+"px");
line.setAttribute("to",(x+w+(part*2)-2)+"px,"+_597+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
if(_587){
_587(g,data[i].src);
}
_589.appendChild(g);
}
return _589;
},Scatter:function(data,_59f,plot,_5a1){
var r=6;
var mod=r/2;
var area=_59f.getArea();
var _5a5=dojo.charting.Plotters._group(_59f);
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_59f,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_59f,plot));
var _5a9=document.createElement("v:rect");
_5a9.setAttribute("strokecolor",data[i].series.color);
_5a9.setAttribute("fillcolor",data[i].series.color);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
_5a9.appendChild(fill);
var s=_5a9.style;
s.position="absolute";
s.rotation="45";
s.top=(y-mod)+"px";
s.left=(x-mod)+"px";
s.width=r+"px";
s.height=r+"px";
_5a5.appendChild(_5a9);
if(_5a1){
_5a1(_5a9,data[i].src);
}
}
return _5a5;
},Bubble:function(data,_5ad,plot,_5af){
var _5b0=1;
var area=_5ad.getArea();
var _5b2=dojo.charting.Plotters._group(_5ad);
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_5ad,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_5ad,plot));
if(i==0){
var raw=data[i].size;
var dy=plot.axisY.getCoord(data[i].y+raw,_5ad,plot)-y;
_5b0=dy/raw;
}
if(_5b0<1){
_5b0=1;
}
var r=(data[i].size/2)*_5b0;
var _5b9=document.createElement("v:oval");
_5b9.setAttribute("strokecolor",data[i].series.color);
_5b9.setAttribute("fillcolor",data[i].series.color);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
_5b9.appendChild(fill);
var s=_5b9.style;
s.position="absolute";
s.rotation="45";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_5b2.appendChild(_5b9);
if(_5af){
_5af(_5b9,data[i].src);
}
}
return _5b2;
}});
dojo.charting.Plotters["Default"]=dojo.charting.Plotters.Line;
}
dojo.provide("dojo.charting.Series");
dojo.charting.Series=function(_5bc){
var args=_5bc||{length:1};
this.dataSource=args.dataSource||null;
this.bindings={};
this.color=args.color;
this.label=args.label;
if(args.bindings){
for(var p in args.bindings){
this.addBinding(p,args.bindings[p]);
}
}
};
dojo.extend(dojo.charting.Series,{bind:function(src,_5c0){
this.dataSource=src;
this.bindings=_5c0;
},addBinding:function(name,_5c2){
this.bindings[name]=_5c2;
},evaluate:function(_5c3){
var ret=[];
var a=this.dataSource.getData();
var l=a.length;
var _5c7=0;
var end=l;
if(_5c3){
if(_5c3.from){
_5c7=Math.max(_5c3.from,0);
if(_5c3.to){
end=Math.min(_5c3.to,end);
}
}else{
if(_5c3.length){
if(_5c3.length<0){
_5c7=Math.max((end+length),0);
}else{
end=Math.min((_5c7+length),end);
}
}
}
}
for(var i=_5c7;i<end;i++){
var o={src:a[i],series:this};
for(var p in this.bindings){
o[p]=this.dataSource.getField(a[i],this.bindings[p]);
}
ret.push(o);
}
if(typeof (ret[0].x)!="undefined"){
ret.sort(function(a,b){
if(a.x>b.x){
return 1;
}
if(a.x<b.x){
return -1;
}
return 0;
});
}
return ret;
},trends:{createRange:function(_5ce,len){
var idx=_5ce.length-1;
var _5d1=(len||_5ce.length);
return {"index":idx,"length":_5d1,"start":Math.max(idx-_5d1,0)};
},mean:function(_5d2,len){
var _5d4=this.createRange(_5d2,len);
if(_5d4.index<0){
return 0;
}
var _5d5=0;
var _5d6=0;
for(var i=_5d4.index;i>=_5d4.start;i--){
_5d5+=_5d2[i].y;
_5d6++;
}
_5d5/=Math.max(_5d6,1);
return _5d5;
},variance:function(_5d8,len){
var _5da=this.createRange(_5d8,len);
if(_5da.index<0){
return 0;
}
var _5db=0;
var _5dc=0;
var _5dd=0;
for(var i=_5da.index;i>=_5da.start;i--){
_5db+=_5d8[i].y;
_5dc+=Math.pow(_5d8[i].y,2);
_5dd++;
}
return (_5dc/_5dd)-Math.pow(_5db/_5dd,2);
},standardDeviation:function(_5df,len){
return Math.sqrt(this.getVariance(_5df,len));
},max:function(_5e1,len){
var _5e3=this.createRange(_5e1,len);
if(_5e3.index<0){
return 0;
}
var max=Number.MIN_VALUE;
for(var i=_5e3.index;i>=_5e3.start;i--){
max=Math.max(_5e1[i].y,max);
}
return max;
},min:function(_5e6,len){
var _5e8=this.createRange(_5e6,len);
if(_5e8.index<0){
return 0;
}
var min=Number.MAX_VALUE;
for(var i=_5e8.index;i>=_5e8.start;i--){
min=Math.min(_5e6[i].y,min);
}
return min;
},median:function(_5eb,len){
var _5ed=this.createRange(_5eb,len);
if(_5ed.index<0){
return 0;
}
var a=[];
for(var i=_5ed.index;i>=_5ed.start;i--){
var b=false;
for(var j=0;j<a.length;j++){
if(_5eb[i].y==a[j]){
b=true;
break;
}
}
if(!b){
a.push(_5eb[i].y);
}
}
a.sort();
if(a.length>0){
return a[Math.ceil(a.length/2)];
}
return 0;
},mode:function(_5f2,len){
var _5f4=this.createRange(_5f2,len);
if(_5f4.index<0){
return 0;
}
var o={};
var ret=0;
var _5f7=Number.MIN_VALUE;
for(var i=_5f4.index;i>=_5f4.start;i--){
if(!o[_5f2[i].y]){
o[_5f2[i].y]=1;
}else{
o[_5f2[i].y]++;
}
}
for(var p in o){
if(_5f7<o[p]){
_5f7=o[p];
ret=p;
}
}
return ret;
}}});
dojo.provide("dojo.charting.Plot");
dojo.charting.RenderPlotSeries={Singly:"single",Grouped:"grouped"};
dojo.charting.Plot=function(_5fa,_5fb,_5fc){
var id="dojo-charting-plot-"+dojo.charting.Plot.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.axisX=null;
this.axisY=null;
this.series=[];
this.dataNode=null;
this.renderType=dojo.charting.RenderPlotSeries.Singly;
if(_5fa){
this.setAxis(_5fa,"x");
}
if(_5fb){
this.setAxis(_5fb,"y");
}
if(_5fc){
for(var i=0;i<_5fc.length;i++){
this.addSeries(_5fc[i]);
}
}
};
dojo.charting.Plot.count=0;
dojo.extend(dojo.charting.Plot,{addSeries:function(_600,_601){
if(_600.plotter){
this.series.push(_600);
}else{
this.series.push({data:_600,plotter:_601||dojo.charting.Plotters["Default"]});
}
},setAxis:function(axis,_603){
if(_603.toLowerCase()=="x"){
this.axisX=axis;
}else{
if(_603.toLowerCase()=="y"){
this.axisY=axis;
}
}
},getRanges:function(){
var xmin,xmax,ymin,ymax;
xmin=ymin=Number.MAX_VALUE;
xmax=ymax=Number.MIN_VALUE;
for(var i=0;i<this.series.length;i++){
var _609=this.series[i].data.evaluate();
for(var j=0;j<_609.length;j++){
var comp=_609[j];
xmin=Math.min(comp.x,xmin);
ymin=Math.min(comp.y,ymin);
xmax=Math.max(comp.x,xmax);
ymax=Math.max(comp.y,ymax);
}
}
return {x:{upper:xmax,lower:xmin},y:{upper:ymax,lower:ymin},toString:function(){
return "[ x:"+xmax+" - "+xmin+", y:"+ymax+" - "+ymin+"]";
}};
},destroy:function(){
var node=this.dataNode;
while(node&&node.childNodes&&node.childNodes.length>0){
node.removeChild(node.childNodes[0]);
}
this.dataNode=null;
}});
dojo.provide("dojo.charting.PlotArea");
dojo.charting.PlotArea=function(){
var id="dojo-charting-plotarea-"+dojo.charting.PlotArea.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.areaType="standard";
this.plots=[];
this.size={width:600,height:400};
this.padding={top:10,right:10,bottom:20,left:20};
this.nodes={main:null,area:null,background:null,axes:null,plots:null};
this._color={h:140,s:120,l:120,step:27};
};
dojo.charting.PlotArea.count=0;
dojo.extend(dojo.charting.PlotArea,{nextColor:function(){
var rgb=dojo.gfx.color.hsl2rgb(this._color.h,this._color.s,this._color.l);
this._color.h=(this._color.h+this._color.step)%360;
while(this._color.h<140){
this._color.h+=this._color.step;
}
return dojo.gfx.color.rgb2hex(rgb[0],rgb[1],rgb[2]);
},getArea:function(){
return {left:this.padding.left,right:this.size.width-this.padding.right,top:this.padding.top,bottom:this.size.height-this.padding.bottom,toString:function(){
var a=[this.top,this.right,this.bottom,this.left];
return "["+a.join()+"]";
}};
},getAxes:function(){
var axes={};
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
axes[plot.axisX.getId()]={axis:plot.axisX,drawAgainst:plot.axisY,plot:plot,plane:"x"};
axes[plot.axisY.getId()]={axis:plot.axisY,drawAgainst:plot.axisX,plot:plot,plane:"y"};
}
return axes;
},getLegendInfo:function(){
var a=[];
for(var i=0;i<this.plots.length;i++){
for(var j=0;j<this.plots[i].series.length;j++){
var data=this.plots[i].series[j].data;
a.push({label:data.label,color:data.color});
}
}
return a;
},setAxesRanges:function(){
var _618={};
var axes={};
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
var _618=plot.getRanges();
var x=_618.x;
var y=_618.y;
var ax,ay;
if(!axes[plot.axisX.getId()]){
axes[plot.axisX.getId()]=plot.axisX;
_618[plot.axisX.getId()]={upper:x.upper,lower:x.lower};
}
ax=_618[plot.axisX.getId()];
ax.upper=Math.max(ax.upper,x.upper);
ax.lower=Math.min(ax.lower,x.lower);
if(!axes[plot.axisY.getId()]){
axes[plot.axisY.getId()]=plot.axisY;
_618[plot.axisY.getId()]={upper:y.upper,lower:y.lower};
}
ay=_618[plot.axisY.getId()];
ay.upper=Math.max(ay.upper,y.upper);
ay.lower=Math.min(ay.lower,y.lower);
}
for(var p in axes){
axes[p].range=_618[p];
}
},render:function(_621,_622){
if(!this.nodes.main||!this.nodes.area||!this.nodes.background||!this.nodes.plots||!this.nodes.axes){
this.initialize();
}
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
this.nodes.plots.removeChild(plot.dataNode);
var _625=this.initializePlot(plot);
switch(plot.renderType){
case dojo.charting.RenderPlotSeries.Grouped:
if(plot.series[0]){
_625.appendChild(plot.series[0].plotter(this,plot,_621,_622));
}
break;
case dojo.charting.RenderPlotSeries.Singly:
default:
for(var j=0;j<plot.series.length;j++){
var _627=plot.series[j];
var data=_627.data.evaluate(_621);
_625.appendChild(_627.plotter(data,this,plot,_622));
}
}
this.nodes.plots.appendChild(_625);
}
},destroy:function(){
for(var i=0;i<this.plots.length;i++){
this.plots[i].destroy();
}
for(var p in this.nodes){
var node=this.nodes[p];
if(!node){
continue;
}
if(!node.childNodes){
continue;
}
while(node.childNodes.length>0){
node.removeChild(node.childNodes[0]);
}
this.nodes[p]=null;
}
}});
dojo.provide("dojo.charting.svg.PlotArea");
if(dojo.render.svg.capable){
dojo.require("dojo.svg");
dojo.extend(dojo.charting.PlotArea,{initializePlot:function(plot){
plot.destroy();
plot.dataNode=document.createElementNS(dojo.svg.xmlns.svg,"g");
plot.dataNode.setAttribute("id",plot.getId());
return plot.dataNode;
},initialize:function(){
this.destroy();
this.nodes.main=document.createElement("div");
this.nodes.area=document.createElementNS(dojo.svg.xmlns.svg,"svg");
this.nodes.area.setAttribute("id",this.getId());
this.nodes.area.setAttribute("width",this.size.width);
this.nodes.area.setAttribute("height",this.size.height);
this.nodes.main.appendChild(this.nodes.area);
var area=this.getArea();
var defs=document.createElementNS(dojo.svg.xmlns.svg,"defs");
var clip=document.createElementNS(dojo.svg.xmlns.svg,"clipPath");
clip.setAttribute("id",this.getId()+"-clip");
var rect=document.createElementNS(dojo.svg.xmlns.svg,"rect");
rect.setAttribute("x",area.left);
rect.setAttribute("y",area.top);
rect.setAttribute("width",area.right-area.left);
rect.setAttribute("height",area.bottom-area.top);
clip.appendChild(rect);
defs.appendChild(clip);
this.nodes.area.appendChild(defs);
this.nodes.background=document.createElementNS(dojo.svg.xmlns.svg,"rect");
this.nodes.background.setAttribute("id",this.getId()+"-background");
this.nodes.background.setAttribute("width",this.size.width);
this.nodes.background.setAttribute("height",this.size.height);
this.nodes.background.setAttribute("fill","#fff");
this.nodes.area.appendChild(this.nodes.background);
this.nodes.plots=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.nodes.plots.setAttribute("id",this.getId()+"-plots");
this.nodes.plots.setAttribute("style","clip-path:url(#"+this.getId()+"-clip);");
this.nodes.area.appendChild(this.nodes.plots);
for(var i=0;i<this.plots.length;i++){
this.nodes.plots.appendChild(this.initializePlot(this.plots[i]));
}
this.nodes.axes=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.nodes.axes.setAttribute("id",this.getId()+"-axes");
this.nodes.area.appendChild(this.nodes.axes);
var axes=this.getAxes();
for(var p in axes){
var obj=axes[p];
this.nodes.axes.appendChild(obj.axis.initialize(this,obj.plot,obj.drawAgainst,obj.plane));
}
return this.nodes.main;
}});
}
dojo.provide("dojo.charting.vml.PlotArea");
if(dojo.render.vml.capable){
dojo.extend(dojo.charting.PlotArea,{initializePlot:function(plot){
plot.destroy();
plot.dataNode=document.createElement("div");
plot.dataNode.id=plot.getId();
return plot.dataNode;
},initialize:function(){
this.destroy();
var main=this.nodes.main=document.createElement("div");
var area=this.nodes.area=document.createElement("div");
area.id=this.getId();
area.style.width=this.size.width+"px";
area.style.height=this.size.height+"px";
area.style.position="absolute";
main.appendChild(area);
var bg=this.nodes.background=document.createElement("div");
bg.id=this.getId()+"-background";
bg.style.width=this.size.width+"px";
bg.style.height=this.size.height+"px";
bg.style.position="absolute";
bg.style.top="0px";
bg.style.left="0px";
bg.style.backgroundColor="#fff";
area.appendChild(bg);
var a=this.getArea();
var _63a=this.nodes.plots=document.createElement("div");
_63a.id=this.getId()+"-plots";
_63a.style.width=this.size.width+"px";
_63a.style.height=this.size.height+"px";
_63a.style.position="absolute";
_63a.style.top="0px";
_63a.style.left="0px";
_63a.style.clip="rect("+a.top+" "+a.right+" "+a.bottom+" "+a.left+")";
area.appendChild(_63a);
for(var i=0;i<this.plots.length;i++){
_63a.appendChild(this.initializePlot(this.plots[i]));
}
var axes=this.nodes.axes=document.createElement("div");
axes.id=this.getId()+"-axes";
area.appendChild(axes);
var ax=this.getAxes();
for(var p in ax){
var obj=ax[p];
axes.appendChild(obj.axis.initialize(this,obj.plot,obj.drawAgainst,obj.plane));
}
return main;
}});
}
dojo.provide("dojo.charting.Chart");
dojo.charting.Chart=function(node,_641,_642){
this.node=node||null;
this.title=_641||"Chart";
this.description=_642||"";
this.plotAreas=[];
};
dojo.extend(dojo.charting.Chart,{addPlotArea:function(obj,_644){
if(obj.x!=null&&obj.left==null){
obj.left=obj.x;
}
if(obj.y!=null&&obj.top==null){
obj.top=obj.y;
}
this.plotAreas.push(obj);
if(_644){
this.render();
}
},onInitialize:function(_645){
},onRender:function(_646){
},onDestroy:function(_647){
},initialize:function(){
if(!this.node){
dojo.raise("dojo.charting.Chart.initialize: there must be a root node defined for the Chart.");
}
this.destroy();
this.render();
this.onInitialize(this);
},render:function(){
if(this.node.style.position!="absolute"){
this.node.style.position="relative";
}
for(var i=0;i<this.plotAreas.length;i++){
var area=this.plotAreas[i].plotArea;
var node=area.initialize();
node.style.position="absolute";
node.style.top=this.plotAreas[i].top+"px";
node.style.left=this.plotAreas[i].left+"px";
this.node.appendChild(node);
area.render();
}
},destroy:function(){
for(var i=0;i<this.plotAreas.length;i++){
this.plotAreas[i].plotArea.destroy();
}
while(this.node&&this.node.childNodes&&this.node.childNodes.length>0){
this.node.removeChild(this.node.childNodes[0]);
}
}});

